/////////////////////////////////////////////////////////////////////////////
// AI Module #1 v.01
//   Main
//     Alpha

// Currently Allows only one AI entity

enum {Primary,Secondary,Tertiary,Bonus,Hidden};
// Actions / Nouns
char *Actions[] = {"Attack",
                   "Defend",
                   "Escort",
                   "Recon",
                   0x0000};
                   
enum {Attack, Defend, Escort, Recon };
//Attack  -  Change TARGET characteristics by weapons / phys
//Defend  -  Maintain TARGET char.
//Escort  -  Follow Unit
//Recon   -  Go to x,y

typedef struct Objective {

int Priority;
int State;
int Action;
int Target; // Unit Index
//class Unit *Object;
// Target changes
int Status;

};

Objective Mission[8];

int genThreat(int Target) {
int i,j,Threat=0;

//  Threat = unit[Target]->Tons * 500;
  for (i=0;i<unit[Target]->Weapons;i++) {
    Threat += (unit[Target]->Weapon[i].Damage * ((unit[Target]->Weapon[i].Missiles+1 )/2)) * unit[Target]->Weapon[i].Long;
    }

if (unit[Target]->Status == Off) return 0;
//Threat = 5;
return Threat;
}

int MissionUpdate(class Unit *AI) {
int i;
int max=0;
for (i=0;i<Units;i++)
  if (unit[i]->Side != AI->Side) // Then it is the enemy
    if (genThreat(i) > max)
      Mission[AI->Index].Target = i;

//if (unit[Target]->Status == Off) return 0;
return 0;
}


int Situation(class Unit *AI) {
int i,Threat;

for (i=0;i<Units;i++)
  if (AI->Side != unit[i]->Side)
    Threat += genThreat(unit[i]->Side);

return Threat;
}

int getMoveCost(Vector Vector, int head)
{
int mpc;
int MP;
int i, o, k;
int x,y,Move = On, dam;
mpc = MPH[Map.Hex[Vector.x][Vector.y].Type];
x = Vector.x + vec[head/30].x;
y = Vector.y + vec[head/30].y;

// AdvanceOpen
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
	}
  // Hex Open, Unit can Advance
if (x<=0 || x >= 60) // Mech Out Off bounds
  Move = Off; // Add Retreat

if (y<=0 || y >= 20) // Mech Out Off bounds
  Move = Off; // Add Retreat

if (Move == On) {
  Vector.x = x;
  Vector.y = y;

  mpc = MPC[Map.Hex[Vector.x][Vector.y].Type] + abs(mpc - MPH[Map.Hex[Vector.x][Vector.y].Alt]);

//  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
//  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  MP = mpc;
  }

if (Move == Off) MP = RETURNNULL;

return MP;
}

int AIMovePhase(class Unit *AI) {
int MP;
MissionUpdate(AI);

Vector cur,des;
cur = AI->Vector;
des = unit[Mission[AI->Index].Target]->Vector;

AI->HexesMoved = 0;
int Range, Modifier;
Range    = doLos(cur.x,cur.y,des.x,des.y);
Range   += abs(getAttackAngle(cur,des)) / 60;
Modifier = ProcLOSstrALT (LOSstring,AI->Altitude,AI->Position,unit[Mission[AI->Index].Target]->Altitude,unit[Mission[AI->Index].Target]->Position);

                                                          MoveType =  2;
if (Range    < AI->getSpeed(1)*2)                         MoveType =  1;
//if (Modifer >= AI->getSpeed(1)/2 && AI->getSpeed(-1) > 0) MoveType = -1;
if (Range == 0)                                           MoveType =  0;

AI->MoveType   = 1; // Walk for now

MP = AI->getSpeed(AI->MoveType);
if (AI->Position == 0) AI->Position = 1, MP-=2;

char String[50];
sprintf(String,"AI %s moves",AI->Name);
putString(String,AI->Colour);
rest(MoveTime);

Worm (AI,des.x,des.y,6,1); // Worm  - Snake towards Target
                             // Snake = Pathfinding Algorythm
//Gardener (AI,des.x,des.y,6,1); // Gardner  - Better Snake towards Target
//Rattler (AI,des.x,des.y,MP,2); // Rattler - Stop at Range
//Sidewinder (AI,des.x,des.y,MP,3); // Sidewinder - Avoids Bad Terrain
//Kite (AI,des.x,des.y,MP,3); // Kite - Improved sidewinder
//Boa (AI,des.x,des.y,MP,3); // Boa - seeks highest hidden terrain Modifier-ND
//Python (AI,des.x,des.y,MP,3); // Python - enhanced Boa - ND
//Adder (AI,des.x,des.y,MP,3); // Adder - enhanced Boa - ND

//getOpenHex(unit[1],unit[0],MP);
//getClosestHex(AI,unit[0],MP);
//getDefenseHex(AI,unit[0],MP);

if (Stacked == On) {
  Stacked = Off;
  Vector = LastVector;
  drawUnits();
  }

return 0;
}

int AISetUp(class Unit *AI) {
int k =0;

Mission[0].Priority = Primary;
Mission[0].State    = On;

Mission[0].Action = Attack;
// Better Assign Target;
Mission[0].Target = 0;

//printf("Current Mission #%d - %s %s\n",k,Actions[Mission[k].Action],unit[Mission[k].Target]->Name);

return 0;
}

int AI (class Unit *AI) {

int k=0;
gotoxy(40,1);
textattr(AI->Colour);
cprintf("Current Mission #%d - %s %s\n",k,Actions[Mission[k].Action],unit[Mission[k].Target]->Name);
AIMovePhase(AI);
return 0;
}


/////////////////////////////////////////////////////////////////////////////
// Weapon Phase
//
//
//

//int AIWeapon(class Unit *AI) {
int AIWeaponPhase(class Unit *AI) {
//char String[60];
int Angle;
//class Unit *Target;
int Target;

char String[50];
sprintf(String,"AI %s Targets",AI->Name);
putString(String,AI->Colour);
rest(WeaponTime);

    Target = Mission[0].Target;

    if (Target != -1) {
      sprintf(String,"Target : [%s]",unit[Target]->Name);
      putString(String,AI->Colour);
      rest(WeaponTime);
      AI->genToHit(*unit[Target]); // Sets Flag as the To Hit
//      Rock(AI,Angle);
      Angle = getAttackAngle(AI->Vector,unit[Target]->Vector);
//      Pilum(AI->m,Angle-AI->Turret);
      Javelin(AI->m,Angle-AI->Turret);
      if (Options.ShowWeaponFire == On)
        AI->ShowWeaponFire(unit[Target]->Vector);

      unit[Target]->ResolveWeapons(AI);

      drawHex (unit[Target]->Vector.x,unit[Target]->Vector.y);
      drawMech(unit[Target]->Vector,unit[Target]->UnitColour,unit[Target]->Position);

      }

return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Reaction Phase
//
//
//

//int AIReaction(class Unit *AI) {
//int AIReactionPhase(class Mech *AI) {
int AIReactionPhase(class Unit *AI) {
char ch=0;
//char String[60];
int Angle;
//class Unit *Target;
int Target;

char String[50];
sprintf(String,"AI %s reacts",AI->Name);
putString(String,AI->Colour);
rest(ReactTime);

    AI->Turret = 0;

    Target = Mission[0].Target;
    Angle = getAttackAngle(AI->Vector,unit[Target]->Vector);

    if (Angle >  60) AI->Turret =  60;
    if (Angle < -60) AI->Turret = -60;
    
return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Physical Phase
//
//
//

int AIPhysicalPhase(class Mech *AI) {
//char String[80];

int RightPunchFlag=1, LeftPunchFlag = 1, KickFlag=1, PushFlag=1, ChargeFlag=1;
int TargetsInRange = 0;
//class Unit *Target;
int Target = Mission[0].Target;
int Angle;
int Range,Modifier,ToHit;

int i;
char ch=0;

//  drawScreen();
char String[50];
/*
sprintf(String,"AI %s attacks",AI->Name);
putString(String,AI->Colour);
rest(PhysTime);
*/
Angle = getAttackAngle(AI->Vector,unit[Target]->Vector);

for (i=0;i<Units;i++) {
  if (AI->Side != unit[i]->Side) {
    Range = doLos(AI->Vector.x,AI->Vector.y,unit[i]->Vector.x,unit[i]->Vector.y);
      if (Range == 1 && Angle < 60 && Angle > -60) Target = i, TargetsInRange ++;
      }
  }

// Unit cannot punch if arm mounted weapons have fired
// Unit cannot kick  if leg mounted weapons have fired
// Unit cannot push  if any arm weapons have fired
// Unit cannot charge if any weapons have fired

if (TargetsInRange > 0 && AI->Position == STANDING) {
for (i=0;i<AI->Weapons;i++)
  if (AI->Flag[i] > 1 && AI->Flag[i] <= 12) {
    if (AI->Weapon[i].Loc == RA || AI->Struct[RA] == 0) RightPunchFlag = 0, PushFlag = 0;
    if (AI->Weapon[i].Loc == LA || AI->Struct[LA] == 0) LeftPunchFlag  = 0, PushFlag = 0;
    if (AI->Weapon[i].Loc == RL || AI->Struct[RL] == 0) KickFlag = 0;
    if (AI->Weapon[i].Loc == LL || AI->Struct[LL] == 0) KickFlag = 0;
    ChargeFlag = 0;
    }


// Physical Preference - Double Punch / Kick / Punch

  if (RightPunchFlag == 1 && LeftPunchFlag == 1) {
    AI->Punch(unit[Target],RA);AI->Punch(unit[Target],LA);}
    else
  if (KickFlag == 1)
    AI->Kick(unit[Target]);
    else
  if (RightPunchFlag == 1 || LeftPunchFlag == 1)
    if (RightPunchFlag == 1) AI->Punch(unit[Target],RA); else AI->Punch(unit[Target],LA);
  }

return 0;
}


