/////////////////////////////////////////////////////////////////////////////
// Movement Radius and simple movement Functions
//
//
//

typedef unsigned char byte;

typedef struct {
byte cost;
byte x;
byte y;
byte head;
} HexCost;

HexCost Hex[36*2][24];

int showMp(int x, int y,int MP) {
gotoxy(x+2,y+2);
if ( Hex[x][y].cost <= MP) {
  textattr(Hex[x][y].cost);
//  textattr(02);
  cprintf("*");
//  cprintf("%c",Hex[x][y].cost);
//  cprintf("%c",Hex[x][y].cost+48);
//  cprintf("%c",Hex[x][y].x+48);
//  cprintf("%c",map.hex[x][y]);
  }
return 0;
}

int initHex() {
int i,j;
for (j=0;j<24;j++)
  for (i=0;i<36*2;i++) {
    Hex[i][j].cost = 127;
    Hex[i][j].x    = 0;
    Hex[i][j].y    = 0;
    Hex[i][j].head = 0;
    }
return 0;
}

int doRadius(class Unit *AI, int MP) {
int i,j;
// 12 2 4 6 8 10
int xi[6] = { 2, 1,-1,-2,-1, 1};
int yi[6] = { 0, 1, 1, 0,-1,-1};
int xj[6] = {-1, 1, 2, 1,-1,-2};
int yj[6] = {-1,-1, 0, 1, 1, 0};
int xc[4][6] = {{-1, 1, 2, 1,-1,-2}, { 1, 2, 1,-1,-2,-1}, {-2,-1, 1, 2, 1,-1}, { 2, 1,-1,-2,-1, 1}};
int yc[4][6] = {{-1,-1, 0, 1, 1, 0}, {-1, 0, 1, 1, 0,-1}, { 0,-1,-1, 0, 1, 1}, { 0, 1, 1, 0,-1,-1}};

int vc[4][6] = {{ 5, 0, 1, 2, 3, 4}, { 0, 1, 2, 3, 4, 5}, { 4, 5, 0, 1, 2, 3}, { 1, 2, 3, 4, 5, 0}};
//int vc[4][6] = {{ 5, 0, 1, 2, 3, 4}, { 0, 1, 2, 3, 4, 5}, { 5, 0, 1, 2, 3, 4}, { 0, 1, 2, 3, 4, 5}};
// Vector

int x,y;

x = AI->Vector.x  ;
y = AI->Vector.y  ;
j=MP; // J = Radius

int a,b,c,d, cost;
int r,k;

r = 5;
for (r=0;r<6;r++)
  for (i=0;i<=MP;i++)  // Check - Might Be wrong
    for (k=0;k<4;k++) { // This loop branches outwards, Mech never turns around

  a = x + (xj[r]*j) + (xi[r]*i);
  b = y + (yj[r]*j) + (yi[r]*i);
  c = a + xc[k][r];
  d = b + yc[k][r];
//  Hex[c][d].cost = 2;

  if (a>=0 && c>=0 && a<=80 && c<=80 && b>=0 && d>=0 && b<=22 && d<=22) { // SLOW!
    cost = Hex[a][b].cost + MPC [ Map.Hex[c][d].Type ] + \
           abs(MPH[Map.Hex[a][b].Alt] - MPH[Map.Hex[c][d].Alt]) + \
           abs(abs(Hex[a][b].head - vc[k][r])>3?6-abs(Hex[a][b].head - vc[k][r]): abs(Hex[a][b].head - vc[k][r]));
           //Change of Heading

    if (cost < Hex[c][d].cost) {
      Hex[c][d].cost = cost;
      Hex[c][d].x = a;      // Hex of Entry
      Hex[c][d].y = b;
      Hex[c][d].head = vc[k][r];
      }

    }
  }

return 0;
}

int doSphere(class Unit *AI, int MP) {
int i,x,y;

initHex();

Hex[AI->Vector.x][AI->Vector.y].cost = 0;
Hex[AI->Vector.x][AI->Vector.y].x    = 1;
Hex[AI->Vector.x][AI->Vector.y].y    = 1;
Hex[AI->Vector.x][AI->Vector.y].head = conHead[AI->Vector.head/30];
//Hex[AI->Vector.x][AI->Vector.y].head = ((AI->Vector.head/30)-1)/2;

for (i=0;i<MP;i++)
  doRadius(AI,i);

  // Shows MP Usage
/*
  for (y= 0;y<20;y++)
    for (x=0;x<36*2;x++)
      showMp(x,y,MP);

      getch();
*/
return 0;
}


int MoveAIMech(class Unit *AI,int fx, int fy)
{
int x[15],y[15];
int fh,range;
int cost,head[15];
int Max,i = 0;
int a,b;
head[i] = Hex[fx][fy].head;
cost    = Hex[fx][fy].cost;

i++;

while (cost > 1) {

cost    = Hex[fx][fy].cost;
head[i] = Hex[fx][fy].head;
x[i]    = Hex[fx][fy].x;
y[i]    = Hex[fx][fy].y;

fx = x[i];
fy = y[i];

i++;
}

Max = i;
i = 1;

// Actually Move the Mech \|/

while (i <= Max) {
  a = ((AI->Vector.head)/60) - head[Max-i];
  a> 2?a=-1:a;
  a<-2?a= 1:a;

  if (a == 0) // Advance
    AI->Advance();
  else        // Rotate
    if (a ==  1)
      AI->TurnLeft ();
    if (a == -1)
      AI->TurnRight();

    i++;
  }

return 0;
}



int getClosestHex(class Unit *AI, class Unit *Target, int MP) {
int x,y,fx,fy,range;
int Closest = 127;
doSphere(AI,MP);

for (y=AI->Vector.y-MP;y<=AI->Vector.y+MP;y++)
  for (x=0;x<36*2;x++) {

    if ( Hex[x][y].cost <= MP ) {
      range = doLos(x,y,Target->Vector.x,Target->Vector.y);
      textattr(range);
      gotoxy(x+2,y+2);
      cprintf("+");

      if (range<Closest) {
        Closest = range;
        fx = x;
        fy = y;
        }

      }
    }

   getch();
   MoveAIMech(AI,fx,fy);

//gotoxy(1,1);
//cprintf(">> %d %d %d",fx,fy,Closest);

return 0;
}

// Hex in the Open
int getOpenHex(class Unit *AI, class Unit *Target, int MP) {
int x,y,fx,fy,range;
int Closest = 127;
int Modifier = 127,Mod;
doSphere(AI,MP);

for (y=AI->Vector.y-MP;y<=AI->Vector.y+MP;y++)
  for (x=0;x<36*2;x++)
    if ( Hex[x][y].cost <= MP ) {
      range = doLos(Target->Vector.x,Target->Vector.y,x,y);
//      if (range<Closest) {
        Mod = ProcLOSstr (LOSstring);
      if (Modifier > Mod) {
        Modifier = Mod;
        fx = x;
        fy = y;
        }
      }

      MoveAIMech(AI,fx,fy);

return 0;
}


int getDefenseHex(class Unit *AI, class Unit *Target, int MP) {
int x,y,cost;
int Closest = 127;
int Modifier = 0 , Mod;
int fx,fy,fh,range;
doSphere(AI,MP);

for (y=AI->Vector.y-MP;y<=AI->Vector.y+MP;y++)
  for (x=0;x<36*2;x++)
    if ( Hex[x][y].cost <= MP ) {
      range = doLos(Target->Vector.x,Target->Vector.y,x,y);
      Mod = ProcLOSstr (LOSstring);
      if (Modifier < Mod) {
        Modifier = Mod;
        fx = x;
        fy = y;
        }
      }

   MoveAIMech(AI,fx,fy);

return 0;
}



