// hmpread.cpp
//

#include <conio.h>
#include "stdafx.h"
#include "hmpread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString GetWeaponLocation( int Loc )
{
	if( Loc == 1 ) return "Left Arm";
	if( Loc == 2 ) return "Left Torso";
	if( Loc == 3 ) return "Left Leg";
	if( Loc == 4 ) return "Right Arm";
	if( Loc == 5 ) return "Right Torso";
	if( Loc == 6 ) return "Right Leg";
	if( Loc == 7 ) return "Head";
	if( Loc == 8 ) return "Center Torso";
	if( Loc == 0x0A ) return "Left Torso (R)";
	if( Loc == 0x0D ) return "Right Torso (R)";
	if( Loc == 0x0F ) return "Head (R)";
	if( Loc == 0x10 ) return "Center Torso (R)";

	CString ret;

	ret.Format( "UnknownWeaponLoc(0x%x)", Loc );

	return ret;
}

CString GetWeaponType( int Type )
{
	CString App = "";
	if( Type & 65536 )
	{
		Type -= 65536;
		App += " (R)";
	}
	
	if( Type == 0x00 ) return "-Empty-";
	if( Type == 0x01 ) return "Shoulder";
	if( Type == 0x02 ) return "Upper Arm Actuator";
	if( Type == 0x03 ) return "Lower Arm Actuator";
	if( Type == 0x04 ) return "Hand Actuator";
	
	if( Type == 0x05 ) return "Hip";
	if( Type == 0x06 ) return "Upper Leg Actuator";
	if( Type == 0x07 ) return "Lower Leg Actuator";
	if( Type == 0x08 ) return "Foot Actuator";

	if( Type == 0x09 ) return "Heat Sink";
	if( Type == 0x0A ) return "Double Heat Sink";
	if( Type == 0x0B ) return "Jump Jet";

	if( Type == 0x0C ) return "Life Support";
	if( Type == 0x0D ) return "Sensors";
	if( Type == 0x0E ) return "Cockpit";

	if( Type == 0x0F ) return "Fusion Engine";
	if( Type == 0x10 ) return "Gyro";

	if( Type == 0x35 ) return "Flamer"+App;
	if( Type == 0x39 ) return "Small Laser"+App;
	if( Type == 0x37 ) return "Large Laser"+App;
	if( Type == 0x38 ) return "Medium Laser"+App;
	if( Type == 0x3A ) return "PPC"+App;
	
	if( Type == 0x3E ) return "AC/2"+App;
	if( Type == 0x3F ) return "AC/5"+App;
	if( Type == 0x40 ) return "AC/10"+App;
	if( Type == 0x41 ) return "AC/20"+App;
	if( Type == 0x4F ) return "Machine Gun"+App;
	
	if( Type == 0x60 ) return "LRM 5"+App;
	if( Type == 0x61 ) return "LRM 10"+App;
	if( Type == 0x62 ) return "LRM 15"+App;
	if( Type == 0x63 ) return "LRM 20"+App;

	if( Type == 0x67 ) return "SRM 2"+App;
	if( Type == 0x68 ) return "SRM 4"+App;
	if( Type == 0x69 ) return "SRM 6"+App;

	if( Type == 0x7B ) return "LRM 5 (OS)"+App;
	if( Type == 0x7C ) return "LRM 10 (OS)"+App;
	if( Type == 0x7D ) return "LRM 15 (OS)"+App;
	if( Type == 0x7E ) return "LRM 20 (OS)"+App;

	if( Type == 0x7F ) return "SRM 2 (OS)"+App;
	if( Type == 0x80 ) return "SRM 4 (OS)"+App;
	if( Type == 0x81 ) return "SRM 6 (OS)"+App;
	
	if( Type == 0x85 ) return "Flamer (Vehicle)"+App;

	if( Type == 0x92 ) return "LR Torpedo 5"+App;
	if( Type == 0x93 ) return "LR Torpedo 10"+App;
	if( Type == 0x94 ) return "LR Torpedo 15"+App;
	if( Type == 0x95 ) return "LR Torpedo 20"+App;

	if( Type == 0x96 ) return "SR Torpedo 2"+App;
	if( Type == 0x97 ) return "SR Torpedo 4"+App;
	if( Type == 0x98 ) return "SR Torpedo 6"+App;

	Type &= 0xFFFF;

	if( Type == 0x01f0 ) return "LRM 5 Ammo";
	if( Type == 0x01f1 ) return "LRM 10 Ammo";
	if( Type == 0x01f2 ) return "LRM 15 Ammo";
	if( Type == 0x01f3 ) return "LRM 20 Ammo";
	if( Type == 0x01ce ) return "AC/2 Ammo";
	if( Type == 0x01d0 ) return "AC/10 Ammo";
	if( Type == 0x01cf ) return "AC/5 Ammo";
	if( Type == 0x01d1 ) return "AC/20 Ammo";
	if( Type == 0x01df ) return "MG Ammo (200)";
	if( Type == 0x01df ) return "MG Ammo (100)";
	if( Type == 0x0215 ) return "Flamer Ammo";
	if( Type == 0x01f7 ) return "SRM 2 Ammo";
	if( Type == 0x01f8 ) return "SRM 4 Ammo";
	if( Type == 0x01f9 ) return "SRM 6 Ammo";
	if( Type == 0x0224 ) return "LR Torpedo 15 Ammo";
	if( Type == 0x0225 ) return "LR Torpedo 20 Ammo";
	if( Type == 0x0222 ) return "LR Torpedo 5 Ammo";
	if( Type == 0x0223 ) return "LR Torpedo 10 Ammo";
	if( Type == 0x0227 ) return "SR Torpedo 4 Ammo";
	if( Type == 0x0226 ) return "SR Torpedo 2 Ammo";
	if( Type == 0x0228 ) return "SR Torpedo 6 Ammo";

	CString ret;

	ret.Format( "UnknownWeaponType(0x%x)", Type );
	
	return ret;
}

CString ISFlags( int F1, int F2, int F3 )
{
	CString ret;

	if( F1 & 1 ) ret += "Davion ";
	if( F1 & 2 ) ret += "Steiner ";
	if( F1 & 4 ) ret += "Draconis ";
	if( F1 & 8 ) ret += "FRR ";
	if( F1 & 16 ) ret += "Liao ";
	if( F1 & 32 ) ret += "Marik ";
	if( F1 & 64 ) ret += "St.Ives ";
	if( F1 & 128 ) ret += "Canopus ";
	
	if( F2 & 1 ) ret += "Outworlds ";
	if( F2 & 2 ) ret += "Taurian ";
	if( F2 & 4 ) ret += "Periphery ";
	if( F2 & 8 ) ret += "Bandit ";
	if( F2 & 16 ) ret += "Comstar ";
	if( F2 & 32 ) ret += "Merc ";
	if( F2 & 64 ) ret += "Blake ";
	if( F2 & 128 ) ret += "Dragoons ";

	if( F3 & 1 ) ret += "User1 ";
	if( F3 & 2 ) ret += "User2 ";
	if( F3 & 4 ) ret += "Chaos ";
	if( F3 & 8 ) ret += "OldLeague ";
	if( F3 & 16 ) ret += "NewLeague ";
	if( F3 & 32 ) ret += "Marian";

	return ret;
}

CString ClanFlags( int F1, int F2, int F3 )
{
	CString ret;

	if( F1 & 1 ) ret += "Spirit ";
	if( F1 & 2 ) ret += "Burrock ";
	if( F1 & 4 ) ret += "Cobra ";
	if( F1 & 8 ) ret += "Coyote ";
	if( F1 & 16 ) ret += "Shark ";
	if( F1 & 32 ) ret += "Mandrill ";
	if( F1 & 64 ) ret += "Bear ";
	if( F1 & 128 ) ret += "Scorpion ";
	
	if( F2 & 1 ) ret += "Horses ";
	if( F2 & 2 ) ret += "Hellion ";
	if( F2 & 4 ) ret += "Falcon ";
	if( F2 & 8 ) ret += "Mongoose ";
	if( F2 & 16 ) ret += "Cat ";
	if( F2 & 32 ) ret += "WolfExile ";
	if( F2 & 64 ) ret += "Fox ";
	if( F2 & 128 ) ret += "Jaguar ";

	if( F3 & 1 ) ret += "Raven ";
	if( F3 & 2 ) ret += "Adder ";
	if( F3 & 4 ) ret += "Viper ";
	if( F3 & 8 ) ret += "Widowmaker ";
	if( F3 & 16 ) ret += "Wolf ";
	if( F3 & 32 ) ret += "Wolverine ";
	if( F3 & 64 ) ret += "User1 ";
	if( F3 & 128 ) ret += "User2 ";
	
	return ret;
}

void ReadHMP( char* M = NULL )
{
	FILE* in;
	FILE* out;

	printf( "<%s>\n", M );

	CString outf;
	if( M != NULL )
	{
		outf = M;
		outf = outf.Left( outf.GetLength()-4 );
		outf += ".MTF";
	}

	if( M == NULL )
	{
		in = fopen( "c:\\progra~1\\heavym~1\\mechs\\3025\\AR4A11~1.HMP", "rb" );
	}
	else
	{
		in = fopen( M, "rb" );
	}

	if( in == NULL )
	{
		printf( "Input File Open Fail\n" );
		return;
	}
	
	if( M == NULL )
	{
		out = fopen( "c:\\progra~1\\heavym~1\\mechs\\3025\\AR4A11~1.MTF", "w" );
	}
	else
	{
		out = fopen( (LPCTSTR)outf, "w" );
	}

	if( out == NULL )
	{
		printf( "Output File Open Fail\n" );
		return;
	}

	int x;

	char			Header[6];

	unsigned char	Unknown[14];
	
	unsigned short	NameLength;
	char			MechName[256];
	unsigned short	ModelLength;
	char			ModelName[256];
	unsigned char	Unknown2[34];

	unsigned char	BF2A[3];
	unsigned char	BF2S[3];
	unsigned char	BF2PB[3];
	unsigned char	BF2PM[3];
	unsigned char	BF2PL[3];
	unsigned char	BF2OH[3];
	unsigned short	BF2StringLength;
	unsigned char	BF2String[256];

	unsigned char	Unknown3A[3];
	unsigned char	Unknown3B[6];

	unsigned short	EngineRating;

	unsigned short	EngineType;

	unsigned short	WalkMP;
	unsigned short	JumpMP;
	unsigned short	Heatsinks;
	unsigned short	HeatsinkType;
	unsigned short	ArmorType;

	unsigned short	Tonnage;

	unsigned short	TechType;
	unsigned short	RulesLevel;
	int				Year;

	unsigned short	NumberOfWeapons;

	unsigned short	Legs;
	unsigned short	InternalType;

	unsigned short	LAArmor, RAArmor, LTArmor, RTArmor, LLArmor, RLArmor, CTArmor, HDArmor, LRArmor, RRArmor, CRArmor;
	unsigned short	MyomerType;

	unsigned short	PlaceHolder;

	unsigned long	Cost;

	// 5 bytes
	// Header, always "V5.00" in HMP 5.x, obviously for file version
	fread( Header, 1,5, in ); Header[5] = 0;

	printf( "Version: %s\n", Header );
	
	// 14 bytes
	// 0		Design Type (1 = Standard, 2 = Modified, 3 = Custom)
	// 1-3		???
	// 4-6		Clan Flags 
	// 7		???
	// 8-10		IS Flags
	// 11		???
	// 12-13	Tonnage
	fread( Unknown, 1,14, in );
//	printf( "Unknown[14]: " ); for( x=0;x<14;x++ ) { int v = (unsigned char)Unknown[x]; printf( "%i ", v); }
// 	printf( "\n" );

	if( Unknown[0] == 1 ) printf( "Standard Design\n" );
	if( Unknown[0] == 2 ) printf( "Modified Design\n" );
	if( Unknown[0] == 3 ) printf( "Custom Design\n" );

	printf( "Clan Flags: %s\n", ClanFlags( Unknown[4], Unknown[5], Unknown[6] ) );
	printf( "IS Flags: %s\n", ISFlags( Unknown[8], Unknown[9], Unknown[10] ) );

	Tonnage = *((unsigned short*)(&Unknown[12]));

	// unsigned short, length of mech name
	fread( &NameLength, 2,1, in );
	printf( "Name Length: %i\n", NameLength );

	// string, mech name, non 0 terminated
	fread( MechName, 1, NameLength, in );
	MechName[NameLength] = 0;
	printf( "Mech Name: %s\n", MechName );

	// unsigned short, length of model name
	fread( &ModelLength, 2,1, in );
	printf( "Model Name Length: %i\n", ModelLength );

	//string, model name, non 0 terminated
	fread( ModelName, 1, ModelLength, in );
	ModelName[ModelLength] = 0;
	printf( "Model Name: %s\n", ModelName );

	// 34 bytes
	// 0-1		Year (Unsigned Short)
	// 2-3		Rules Level
	// 4-7		Cost
	// 8-29		???
	// 30-31	BF2 String Length + 16(???)
	// 32-33	???
	
	fread( Unknown2, 1,34, in );
//	printf( "Unknown2[34]: " ); for( x=0;x<34;x++ ) { int v = (unsigned char)Unknown2[x]; printf( "%i ", v); }
//	printf( "\n" );

	Cost = (unsigned long)*((unsigned long*)&Unknown2[4]);
	printf( "Cost:%i\n", Cost );

	BF2StringLength = (unsigned short)*((unsigned short*)&Unknown2[30]);
	BF2StringLength -= 16;
	
	RulesLevel = (unsigned short)*((unsigned short*)&Unknown2[2]);
	printf( "Rules Level: %i\n", RulesLevel );

	Year = (unsigned short)*((unsigned short*)&Unknown2[0]);
	printf( "Year/Era: %i\n", Year );

	// Battle Force 2 Stats
	fread( BF2A, 1,2, in );	BF2A[2] = 0;
	fread( BF2S, 1,2, in ); BF2S[2] = 0;
	fread( BF2PB, 1,2, in ); BF2PB[2] = 0;
	fread( BF2PM, 1,2, in ); BF2PM[2] = 0;
	fread( BF2PL, 1,2, in ); BF2PL[2] = 0;
	fread( BF2OH, 1,1, in ); BF2OH[1] = 0;

	if( BF2A[1] == 151 ) BF2A[1] = '-';
	if( BF2S[1] == 151 ) BF2S[1] = '-';
	if( BF2PB[1] == 151 ) BF2PB[1] = '-';
	if( BF2PM[1] == 151 ) BF2PM[1] = '-';
	if( BF2PL[1] == 151 ) BF2PL[1] = '-';
	if( BF2OH[0] == 151 ) BF2OH[0] = '-';

	printf( "BF2: %s %s %s %s %s  %s\n", BF2A, BF2S, BF2PB, BF2PM, BF2PL, BF2OH );

	// 9 bytes
	// 0-2	???
	// 3-4	Clan/IS (0 = IS, 1 = Clan)
	// 5-6	Quad/Biped
	// 7-8	Internal Structure
	fread( Unknown3A, 1, 3, in );
//	printf( "Unknown3[9]: " ); for( x=0;x<9;x++ ) { int v = (unsigned char)Unknown3[x]; printf( "%i ", v); }
//	printf( "\n" );

	if( BF2StringLength > 0 )
	{
		fread( BF2String, 1, BF2StringLength, in );
		BF2String[BF2StringLength] = 0;
	}
	else
	{
		BF2String[0] = 0;
	}

	printf( "BF2String: %s\n", BF2String );

	fread( Unknown3B, 1,6, in );

	TechType = (unsigned short)*((unsigned short*)&Unknown3B[0]);

	if( TechType == 0 ) printf( "Inner Sphere\n" );
	if( TechType == 1 ) printf( "Clan\n" );

	Legs = (unsigned short)*((unsigned short*)&Unknown3B[2]);

	if( Legs == 0 ) printf( "Biped Type\n" );
	if( Legs == 1 ) printf( "Quad Type\n" );
	if( Legs == 2 ) printf( "LAM Type\n" );
	if( Legs == 3 ) printf( "Armless Type\n" );

	InternalType = (unsigned short)*((unsigned short*)&Unknown3B[4]);	

	if( InternalType == 0 ) printf( "Standard Internal\n" );
	if( InternalType == 1 ) printf( "Endo Steel\n" );
	if( InternalType == 2 ) printf( "Composite IS\n" );
	if( InternalType == 3 ) printf( "Reinforced IS\n" );
	if( InternalType == 4 ) printf( "Utility Mech IS\n" );

	// unsigned short, engine rating
	fread( &EngineRating, 2,1, in );
	printf( "Engine Rating: %i\n", EngineRating );

	// unsigned short, engine type
	fread( &EngineType, 2,1, in );
	if( EngineType == 0 ) printf( "Fusion Engine\n" );
	if( EngineType == 1 ) printf( "XL Engine\n" );
	if( EngineType == 2 ) printf( "XXL Engine\n" );
	if( EngineType == 3 ) printf( "Compact Engine\n" );
	if( EngineType == 4 ) printf( "I.C.E. Engine\n" );

	// unsigned short, walp MP
	fread( &WalkMP, 2,1, in );
	printf( "WalkMP: %i\n", WalkMP );

	// unsigned short, jump MP
	fread( &JumpMP, 2,1, in );
	printf( "JumpMP: %i\n", JumpMP );

	// unsigned short, number heatsinks
	fread( &Heatsinks, 2,1, in );
	printf( "Heatsinks: %i\n", Heatsinks );

	// unsigned short, heatsink type
	fread( &HeatsinkType, 2,1, in );
	if( HeatsinkType == 0 ) printf( "Single Sinks\n" );
	if( HeatsinkType == 1 ) printf( "Double Sinks\n" );
	if( HeatsinkType == 2 && TechType == 0 ) printf( "Compact Sinks\n" );
	if( HeatsinkType == 2 && TechType == 1 ) printf( "Laser Sinks\n" );

	// unsigned short, armor type
	fread( &ArmorType, 2,1, in );
	if( ArmorType == 0 ) printf( "Standard Armor\n" );
	if( ArmorType == 1 ) printf( "Ferro-Fibrous\n" );
	if( ArmorType == 2 ) printf( "Stealth Armor\n" );
	if( ArmorType == 3 ) printf( "Reactive Armor\n" );
	if( ArmorType == 4 ) printf( "Laser Reflec Armor\n" );
	if( ArmorType == 5 ) printf( "Hardened Armor\n" );
	if( ArmorType == 6 ) printf( "Light FF Armor\n" );
	if( ArmorType == 7 ) printf( "Heavy FF Armor\n" );
	if( ArmorType == 8 ) printf( "Patchwork Armor\n" );

	fread( &PlaceHolder, 2,1, in );

	fread( &LAArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &LTArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &LLArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &RAArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &RTArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &RLArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &HDArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );
	fread( &PlaceHolder, 2,1, in );

	fread( &CTArmor, 2,1, in );

	fread( &PlaceHolder, 2,1, in );

	fread( &LRArmor, 2,1, in );
	fread( &RRArmor, 2,1, in );
	fread( &CRArmor, 2,1, in );

	printf( "Armor: LA:%i RA:%i LL:%i RL:%i LT:%i RT:%i CT:%i HD:%i LR:%i RR:%i CR:%i\n", LAArmor, RAArmor, LLArmor, RLArmor, LTArmor, RTArmor, CTArmor, HDArmor, LRArmor, RRArmor, CRArmor );

	fread( &MyomerType, 2,1, in );

	if( MyomerType == 0 ) printf( "Standard Myomer\n" );
	if( MyomerType == 1 ) printf( "Triple-Strength Myomer\n" );
	if( MyomerType == 2 ) printf( "MASC\n" );

	fread( &NumberOfWeapons, 2,1, in );

	printf( "Number of Weapons: %i\n", NumberOfWeapons );

	////
	// Begin Equipment Section

	struct WeaponType
	{
		CString Name;
		
		int		Number;
		int		Ammo;
		CString	Location;
	};

	WeaponType	Weapon[256];

	for( x=0;x<NumberOfWeapons;x++ )
	{
		unsigned short WeaponNumber;
		unsigned short WeaponType;
		unsigned short WeaponLoc;
		unsigned short WeaponAmmo;
		unsigned short WeaponU2;
		unsigned short WeaponMakerLength;

		fread( &WeaponNumber, 2,1, in );
		fread( &WeaponType, 2,1, in );
		fread( &WeaponLoc, 2,1, in );
		fread( &WeaponAmmo, 2,1, in );
		fread( &WeaponU2, 2,1, in );
		fread( &WeaponMakerLength, 2,1, in );

		CString Maker = "";

		for( int y=0;y<WeaponMakerLength;y++ ) Maker += fgetc( in );

		CString type = GetWeaponType( WeaponType );
		CString loc = GetWeaponLocation( WeaponLoc );

		Weapon[x].Name = type;
		Weapon[x].Location = loc;
		Weapon[x].Ammo = WeaponAmmo;
		Weapon[x].Number = WeaponNumber;

		printf( "Weapon #%i : %i %s %s Ammo:%i ?%i %s\n", x, WeaponNumber, type, loc, WeaponAmmo, WeaponU2, Maker );
	} 

	printf( "\n" );
	printf( "Critical Slots:\n\n" );

	unsigned long	LACrit[12];
	
	printf( "Left Arm:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		LACrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	LTCrit[12];

	printf( "Left Torso:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		LTCrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	LLCrit[12];

	printf( "Left Leg:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		LLCrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	RACrit[12];

	printf( "Right Arm:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		RACrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	RTCrit[12];

	printf( "Right Torso:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		RTCrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	RLCrit[12];

	printf( "Right Leg:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		RLCrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	HDCrit[12];

	printf( "Head:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		HDCrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	unsigned long	CTCrit[12];

	printf( "Center Torso:\n" );
	for( x=0;x<12;x++ )
	{
		unsigned long Slot;

		fread( &Slot, 4,1, in );

		CTCrit[x] = Slot;

		printf( "%s\n", GetWeaponType( Slot ) );
	}	
	printf( "\n" );

	printf( "Tonnage:%i\n", Tonnage );

	printf( "\n" );

	fclose( in );

	////
	// Write Output MTF
	fprintf( out, "%s\n", MechName );
	fprintf( out, "%s\n", ModelName );
	fprintf( out, "\n" );

	if( Legs == 0 ) fprintf( out, "Config:Biped\n" );
	if( Legs == 1 ) fprintf( out, "Config:Quad\n" );
	if( Legs == 2 ) fprintf( out, "Config:LAM\n" );
	if( Legs == 3 ) fprintf( out, "Config:Armless\n" );
	
	if( TechType == 0 )
	{
		fprintf( out, "TechBase:Inner Sphere\n" );
	}
	else
	{
		fprintf( out, "TechBase:Clan\n" );
	}

	fprintf( out, "Era:%i\n", Year );
	fprintf( out, "Rules Level:%i\n", RulesLevel );
	fprintf( out, "\n" );
	
	fprintf( out, "Mass:%i\n", Tonnage );
	fprintf( out, "Engine:%i ", EngineRating );
	
	if( EngineType == 0 ) fprintf( out, "Fusion Engine\n" );
	if( EngineType == 1 ) fprintf( out, "XL Engine\n" );
	if( EngineType == 2 ) fprintf( out, "XXL Engine\n" );
	if( EngineType == 3 ) fprintf( out, "Compact Engine\n" );
	if( EngineType == 4 ) fprintf( out, "I.C.E. Engine\n" );

	if( InternalType == 0 ) fprintf( out,"Structure:Standard\n" );
	if( InternalType == 1 ) fprintf( out,"Structure:Endo Steel\n" );
	if( InternalType == 2 ) fprintf( out,"Structure:Composite\n" );
	if( InternalType == 3 ) fprintf( out,"Structure:Reinforced\n" );
	if( InternalType == 4 ) fprintf( out,"Structure:Utility Mech\n" );

	fprintf( out, "Myomer:" );
	if( MyomerType == 0 ) fprintf( out, "Standard\n" );
	if( MyomerType == 1 ) fprintf( out, "Triple-Strength\n" );
	if( MyomerType == 2 ) fprintf( out, "MASC\n" );

	fprintf( out, "\n" );
	fprintf( out, "Heat Sinks:%i ", Heatsinks );

	if( HeatsinkType == 0 ) fprintf( out, "Single\n" );
	if( HeatsinkType == 1 ) fprintf( out, "Double\n" );
	if( HeatsinkType == 2 && TechType == 0 ) fprintf( out, "Compact\n" );
	if( HeatsinkType == 2 && TechType == 1 ) fprintf( out, "Laser\n" );

	fprintf( out, "Walk MP:%i\n", WalkMP );
	fprintf( out, "Jump MP:%i\n", JumpMP );

	fprintf( out, "\n" );

	fprintf( out, "Armor:" );
	if( ArmorType == 0 ) fprintf( out, "Standard Armor\n" );
	if( ArmorType == 1 ) fprintf( out, "Ferro-Fibrous\n" );
	if( ArmorType == 2 ) fprintf( out, "Stealth Armor\n" );
	if( ArmorType == 3 ) fprintf( out, "Reactive Armor\n" );
	if( ArmorType == 4 ) fprintf( out, "Laser Reflec Armor\n" );
	if( ArmorType == 5 ) fprintf( out, "Hardened Armor\n" );
	if( ArmorType == 6 ) fprintf( out, "Light FF Armor\n" );
	if( ArmorType == 7 ) fprintf( out, "Heavy FF Armor\n" );
	if( ArmorType == 8 ) fprintf( out, "Patchwork Armor\n" );

	fprintf( out, "LA Armor:%i\n", LAArmor );
	fprintf( out, "RA Armor:%i\n", RAArmor );
	fprintf( out, "LT Armor:%i\n", LTArmor );
	fprintf( out, "RT Armor:%i\n", RTArmor );
	fprintf( out, "CT Armor:%i\n", CTArmor );
	fprintf( out, "HD Armor:%i\n", HDArmor );
	fprintf( out, "LL Armor:%i\n", LLArmor );
	fprintf( out, "RL Armor:%i\n", RLArmor );
	fprintf( out, "RTL Armor:%i\n", LRArmor );
	fprintf( out, "RTR Armor:%i\n", RRArmor );
	fprintf( out, "RTC Armor:%i\n", CRArmor );

	fprintf( out, "\n" );

	fprintf( out, "Weapons:%i\n", NumberOfWeapons );
	
	for( x=0;x<NumberOfWeapons;x++ )
	{
		if( Weapon[x].Ammo > 0 )
		{
			fprintf( out, "%i %s, %s, Ammo:%i\n", Weapon[x].Number, Weapon[x].Name, Weapon[x].Location, Weapon[x].Ammo );
		}
		else
		{
			fprintf( out, "%i %s, %s\n", Weapon[x].Number, Weapon[x].Name, Weapon[x].Location );
		}
	}

	fprintf( out, "\n" );
	fprintf( out, "Left Arm:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( LACrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Right Arm:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( RACrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Left Torso:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( LTCrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Right Torso:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( RTCrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Center Torso:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( CTCrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Head:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( HDCrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Left Leg:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( LLCrit[x] ) );
	fprintf( out, "\n" );

	fprintf( out, "Right Leg:\n" );
	for( x=0;x<12;x++ ) fprintf( out, "%s\n", GetWeaponType( RLCrit[x] ) );
	fprintf( out, "\n" );


	fclose( out );

}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	if( __argc > 1 )
	{
		CString File;

		for( int x=1;x<__argc;x++ )
		{
			File += __argv[x];

			if( x != __argc-1 ) File += " ";
		}

		WIN32_FIND_DATA	fd;
		HANDLE ffh;
		bool ret;
		int found;

		ffh = FindFirstFile( File, &fd );

		ret = true;
		found = 0;

		while( (ffh != (HANDLE)INVALID_HANDLE_VALUE) && (ffh != (HANDLE)ERROR_NO_MORE_FILES) && ret )
		{
			CString Path = File;

			if( Path.ReverseFind( '\\' ) != -1 )
			{
				Path = Path.Left( Path.ReverseFind( '\\' )+1 );
			}
			else
			{
				Path = "";
			}

			if( !(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
			if( strcmp( fd.cFileName, "." ) != 0 )
			if( strcmp( fd.cFileName, ".." ) != 0 )
			{
				CString FN;

				FN = Path + fd.cFileName;

				ReadHMP( (char*)(LPCTSTR)FN );
			}

			ret = FindNextFile( ffh, &fd );
		}

		FindClose( ffh );
	}
	else
	{
		printf( "\n" );
		printf( "HMPRead.EXE Alpha 2\n" );
		printf( "Freeware\n" );
		printf( "\n" );
		printf( "HMPRead is a utility to convert HMP files to a text-based format\n" );
		printf( "Usage: HMPRead \"filespec\"\n" );
		printf( "\n" );
		printf( "  filespec     Name of file, or filename with wildcards to convert from .HMP to\n" );
		printf( "               .MTF format\n" );
		printf( "\n" );
	}

	return 0;
}


