/////////////////////////////////////////////////////////////////////////////
// Functions to load the more complicated .MEC Files
//
//
//

// Data needs to be shifted because 13 & 255 can generate errors
//  -- OR Written in Binary!

typedef struct rWeaponData {
char Type;  // SMLS / MDLS
int  Loc ;
int  Ammo;  // -1 Energy
int  Damage;
char Status;
};

typedef struct rMechCriticals {
char Class;  // Engine / Actuators / Weapons / Ammo
char Type;   // SMLS / MDLS .. etc
char Size;
char Status;  // 0 = OnLine, 1 .. 8 OffLine
};

class rMech {
public:
int  TechBase;

char Name[40];
char Code[40];
int  Type;
int  Tons;
int  Walk;
int  Run;
int  Sprint;
int  Jump;

int  HeatSinks;

int  EngineType;
int  GyroType;
int  CockPitType;
int  SensorType;

int  MyomerType;
int  StructType;
int  ArmourType;
int  HeatSinkType;

int  NullSigType;
int  HatchetType;
int  BAPType;
int  ECMType;
int  CompType;
int  ARTType;

int  CaseType;
int  CaseLoc;

int LeftArm,RightArm;
int Armour[12];
int Struct[12];

int PrimeWeapon;

int Weapons;
WeaponData Weapon[40];

int CritSlot[12];
MechCriticals Crit[8][12];

} Mech;

int readString(char *String, FILE *ReadFile)
{
char ch = 1;
int  i = 0;
while (ch != 10 && ch != 13 && ch !=0x0000) {
  ch = fgetc(ReadFile);
  String[i] = ch;
  i++;
  }

  String[i-1] = 0;
return i;
}

int LoadMech(char *Name)
{
char String[30];
FILE *MechOut;

sprintf(String,"%s.mec",Name);

MechOut = fopen(String,"rb");
if (MechOut == NULL) return 1;
/////////////////////////////////////////////////////////////////////////////
// File Header
// ALWAYS 12 BYTES in length
//

fgetc(MechOut);           // 0 - BattleMech 1 - Vehicle etc..
Mech.TechBase=fgetc(MechOut);    // 0 - InnerSphere 1 - StarLeague 2 - Clan 3 - Custom
readString(String,MechOut);  // File Class
fgetc(MechOut);           // IE Version 1.0, 2.0
fgetc(MechOut);           // IE Version  .2   .7
fgetc(MechOut);           // Release Version  / Alpha / Beta / Gamma

// All data needs to be shifted because 13 & 255 cause errors

readString(Mech.Name,MechOut);
readString(Mech.Code,MechOut);
Mech.Type=fgetc(MechOut);       //  0 - Biped 1 - Quad 2 - Lam 3 - OmniMech
Mech.Tons=fgetc(MechOut);
Mech.Walk=fgetc(MechOut);
Mech.Jump=fgetc(MechOut);

// Pod Weight?
//putc(HeatSinkType) // 0 - Normal 1 - Double 2 - Clan 3 - Compact 4 - Laser
Mech.HeatSinks=fgetc(MechOut);

Mech.LeftArm =fgetc(MechOut); // The Arms Length, 2-4
Mech.RightArm=fgetc(MechOut);

int i,j;             // 0 1 2 3 4 5 6 7 8 9 0
for (i=0;i<11;i++) {
  Mech.Armour[i]=fgetc(MechOut);
  }
for (i=0;i<8 ;i++) {
  Mech.Struct[i]=fgetc(MechOut);
  }

printf("Armour\n");
// Derived

//int   MaxAF,CurAF;
//float MaxArmourTons,CurArmourTons;

//  putc(127,MechOut); // End Main
fgetc(MechOut);
// Put Equipment Type

Mech.EngineType  =fgetc(MechOut);
Mech.GyroType    =fgetc(MechOut);
Mech.CockPitType =fgetc(MechOut);
Mech.SensorType  =fgetc(MechOut);

Mech.MyomerType  =fgetc(MechOut);
Mech.StructType  =fgetc(MechOut);
Mech.ArmourType  =fgetc(MechOut);
Mech.HeatSinkType=fgetc(MechOut);

Mech.NullSigType =fgetc(MechOut);
Mech.HatchetType =fgetc(MechOut);
Mech.BAPType     =fgetc(MechOut);
Mech.ECMType     =fgetc(MechOut);
Mech.CompType    =fgetc(MechOut);
Mech.ARTType     =fgetc(MechOut);

Mech.CaseType    =fgetc(MechOut);
Mech.CaseLoc     =fgetc(MechOut);

//  putc(127,MechOut); // End Type
fgetc(MechOut);
//genWeaponTable();
Mech.Weapons=fgetc(MechOut);
for (i=0;i<Mech.Weapons;i++) {
  Mech.Weapon[i].Type=fgetc(MechOut);
  Mech.Weapon[i].Loc =fgetc(MechOut);
  }

//  putc(127,MechOut); // End Weapon
fgetc(MechOut);

for (i=0;i<8;i++) {
  Mech.CritSlot[i]=fgetc(MechOut);
  for (j=0;j<Mech.CritSlot[i];j++) {
    Mech.Crit[i][j].Class =fgetc(MechOut);
    Mech.Crit[i][j].Type  =fgetc(MechOut);
    Mech.Crit[i][j].Size  =fgetc(MechOut);
    Mech.Crit[i][j].Status=fgetc(MechOut);
    }
  }
//  putc(127,MechOut); // End Crit
//fgetc(MechOut);
//Put Terminators

fclose(MechOut);

return 0;

}

/*
int Show();

int main(int argc, char *argv[])
{

   if (argc != 2) {
      printf("Usage: MechName\n");
      return 1;
   }

clrscr();

LoadMech(argv[1]);

Show();

return 0;
}

int Show() {
int y1;
textattr(07);

y1 = 1;
//x2 = x1 + 25;
//y2 = y1 + 15;

clrscr();
gotoxy(1,y1+1);
cprintf("%s : %s \n",Mech.Code,Mech.Name);
gotoxy(1,y1+2);
cprintf("Tons %d Walk %d Run %d Jump %d  \n",Mech.Tons,Mech.Walk,Mech.Run,Mech.Jump);
cprintf("\r HS %d RA %d LA %d \r\n",Mech.HeatSinks,Mech.RightArm,Mech.LeftArm);
int i,j;
for (i=0;i<8;i++)
  gotoxy(1,5+i),
  cprintf(" %d  %d  \n",Mech.Armour[i],Mech.Struct[i]);

for (i=8;i<11;i++)
  gotoxy(1,5+i),
  cprintf(" %d   \n",Mech.Armour[i]);

//  gotoxy(30,24);
//  cprintf("%s\n",Functional[Status]);

for (i=0;i<Mech.Weapons;i++) {
  gotoxy(30,4+i);
  cprintf("%d \n",Mech.Weapon[i].Type);
//  gotoxy(60,4+i);
//  cprintf("%d       \n",WeaponTable[Weapon[i].Type].Dam);
  }

  gotoxy(1,16);
  for (i=0;i<8;i++) {
    printf("\n");
    for (j=0;j<Mech.CritSlot[i];j++)
      printf("<%d %d>",Mech.Crit[i][j].Class,Mech.Crit[i][j].Type);
    }
//getch();

return 0;
}
*/
