/////////////////////////////////////////////////////////////////////////////
// AI Module #1 v.01
//   Main
//     Alpha

// Currently Allows only one AI entity

enum {Primary,Secondary,Tertiary,Bonus,Hidden};
// Actions / Nouns
char *Actions[] = {"Attack",
                   "Defend",
                   "Escort",
                   "Recon",
                   0x0000};
                   
enum {Attack, Defend, Escort, Recon };
//Attack  -  Change TARGET characteristics by weapons / phys
//Defend  -  Maintain TARGET char.
//Escort  -  Follow Unit
//Recon   -  Go to x,y

typedef struct Objective {

int Priority;
int State;
int Action;
int Target; // Unit Index
//class Unit *Object;
// Target changes
int Status;

};

Objective Mission[8];

int genThreat(int Target) {
int i,j,Threat=0;

//  Threat = unit[Target]->Tons * 500;
  for (i=0;i<unit[Target]->Weapons;i++) {
    Threat += (unit[Target]->Weapon[i].Damage * ((unit[Target]->Weapon[i].Missiles+1 )/2)) * unit[Target]->Weapon[i].Long;
    }

if (unit[Target]->Status == Off) return 0;
//Threat = 5;
return Threat;
}

int MissionUpdate(class Unit *AI) {
int i;
int max=0;
for (i=0;i<Units;i++)
  if (unit[i]->Side != AI->Side) // Then it is the enemy
    if (genThreat(i) > max)
      Mission[AI->Index].Target = i;

//if (unit[Target]->Status == Off) return 0;
return 0;
}


int Situation(class Unit *AI) {
int i,Threat;

for (i=0;i<Units;i++)
  if (AI->Side != unit[i]->Side)
    Threat += genThreat(unit[i]->Side);

return Threat;
}

int getMoveCost(Vector Vector, int head)
{
int mpc;
int MP;
int i, o, k;
int x,y,Move = On, dam;
mpc = MPH[Map.Hex[Vector.x][Vector.y].Type];
x = Vector.x + vec[head/30].x;
y = Vector.y + vec[head/30].y;

// AdvanceOpen
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
	}
  // Hex Open, Unit can Advance
if (x<=0 || x >= 60) // Mech Out Off bounds
  Move = Off; // Add Retreat

if (y<=0 || y >= 20) // Mech Out Off bounds
  Move = Off; // Add Retreat

if (Move == On) {
  Vector.x = x;
  Vector.y = y;

  mpc = MPC[Map.Hex[Vector.x][Vector.y].Type] + abs(mpc - MPH[Map.Hex[Vector.x][Vector.y].Alt]);

//  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
//  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  MP = mpc;
  }

if (Move == Off) MP = RETURNNULL;

return MP;
}

int Mech::AIMovePhase() {
int MP,Min;
struct Vector cur,des;
MissionUpdate(u);

cur = Vector;
des = unit[Mission[Index].Target]->Vector;

HexesMoved = 0;
MoveType   = 1; // Walk for now

int Range, Modifier;
Range    = doLos(cur.x,cur.y,des.x,des.y);
Range   += abs(getAttackAngle(cur,des)) / 60;
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position,unit[Mission[Index].Target]->Altitude,unit[Mission[Index].Target]->Position);

//MissionUpdate(u);

                                                  MoveType =  2;
if (Range    < getSpeed(1)*2)                     MoveType =  1;
if (Modifier >= getSpeed(1)/2 && getSpeed(-1)> 0) MoveType = -1;
if (Range == 0)                                   MoveType =  0;

MP = getSpeed(MoveType);
//if (Position == 0) Position = 1, MP-=2;
if (Position == 0 && genPilotModifier()-Pilot.StandBonus < 12)
  while (Position == 0 && MP > 0 && genPilotModifier()-Pilot.StandBonus < 12)
    Stand();

char String[50];
sprintf(String,"AI %s moves",Name);
putString(String,Colour);
rest(MoveTime);

Min = 1;
if (Tons >= 60 || RightMelee != 0 || RightMelee != 0) Min = 0;
if (Pilot.AILevel >= 2 && unit[Mission[Index].Target]->Used == Off) {
  Min = 2;
  if (unit[Mission[Index].Target]->getSpeed(-1) > 0) Min = unit[Mission[Index].Target]->getSpeed(-1);
  }

switch (Pilot.AILevel) {
case 0: Worm (u,des.x,des.y,MP,Min); break; // Worm  - Snake towards Target
                             // Snake = Pathfinding Algorythm
//Gardener (AI,des.x,des.y,6,1); // Gardner  - Better Snake towards Target
case 1: Rattler (u,des.x,des.y,MP,Min); break; // Rattler - Stop at Range
case 2: SideWinder (u,des.x,des.y,MP,Min); break ;// Sidewinder - Avoids Bad Terrain
case 3: Kite (u,des.x,des.y,MP,Min); break; // Kite - Improved sidewinder
//Boa (AI,des.x,des.y,MP,3); // Boa - seeks highest hidden terrain Modifier-ND
//Python (AI,des.x,des.y,MP,3); // Python - enhanced Boa - ND
//Adder (AI,des.x,des.y,MP,3); // Adder - enhanced Boa - ND
default: Worm (u,des.x,des.y,MP,Min); break; // Worm  - Snake towards Target
}

if (MoveType != -1) {
  if (MP >= getSpeed(2)-getSpeed(1)) MoveType = 1;
  if (MP == getSpeed(2))             MoveType = 0;
  }
//getOpenHex(unit[1],unit[0],MP);
//getClosestHex(AI,unit[0],MP);
//getDefenseHex(AI,unit[0],MP);

if (Stacked == On) {
  Stacked = Off;
  Vector = LastVector;
  drawUnits();
  }

  Used = On;
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);

return 0;
}

int AISetUp(class Unit *AI) {
int k =0;

Mission[AI->Index].Priority = Primary;
Mission[AI->Index].State    = On;

Mission[AI->Index].Action = Attack;
// Better Assign Target;
Mission[AI->Index].Target = 0;

//printf("Current Mission #%d - %s %s\n",k,Actions[Mission[k].Action],unit[Mission[k].Target]->Name);

return 0;
}

int AI (class Unit *AI) {

int k=0;
//gotoxy(40,1);
//textattr(AI->Colour);
//cprintf("Current Mission #%d - %s %s\n",k,Actions[Mission[k].Action],unit[Mission[k].Target]->Name);
//AIMovePhase(AI);
return 0;
}
/*
int Mech::AIGetMoveCost(Vector TestVector, int head) {

// Cost to Move into Hex +
// Alt Change
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;

x = TestVector.x + vec[head/30].x;
y = TestVector.y + vec[head/30].y;

// if (AdvanceOpen())
// AdvanceOpen
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) )
        if (Options.Stacking==On)
          if (unit[i]->Side!=Side&&unit[i]->Type<INFANTRY&&MoveType>=0)
   	    Move = Off; // Can't stack with an enemy on the ground


  // Hex Open, Unit can Advance
if (x<Xmin || x >= Xmax) // Mech Out Off bounds
   Move = Off;

if (y<Ymin || y >= Ymax) // Mech Out Off bounds
   Move = Off;

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;
  if (Options.AltChangeLimit == On) // Limit Altitude change per hex
    if (abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight) > 2)
      Move=Off;

  if (Options.RunInWater == Off)
  if (MoveType >= 1)
    if (Map.Hex[x][y].Type == 'w' && MPH[Map.Hex[x][y].Alt] > '0') Move = Off; // If water deeper then a number

  if (Map.Hex[TestVector.x][TestVector.y].Type == 'L') BuildingHeight = -1;
  if (Map.Hex[TestVector.x][TestVector.y].Type == 'M') BuildingHeight = -2;
  if (Map.Hex[TestVector.x][TestVector.y].Type == 'H') BuildingHeight = -2;
  if (Map.Hex[TestVector.x][TestVector.y].Type == 'A') BuildingHeight = -3;

  if (Map.Hex[x][y].Type == 'L') BuildingHeight += 1;
  if (Map.Hex[x][y].Type == 'M') BuildingHeight += 2;
  if (Map.Hex[x][y].Type == 'H') BuildingHeight += 2;
  if (Map.Hex[x][y].Type == 'A') BuildingHeight += 3;

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(TestVector.x,TestVector.y) && onRoad(x,y)) // Handles MultiLevel Bridges
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0? \
     (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt] - RoadHeight(TestVector.x,TestVector.y) + MPH[Map.Hex[TestVector.x][TestVector.y].Alt} ):0;

  mpc += abs(MPH[Map.Hex[TestVector.x][TestVector.y].Alt] - MPH[Map.Hex[x][y].Alt])+abs(BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  Submersed==On?mpc+=4:mpc; // If Mech under water

  if (MoveType < 0 && Jump >= MPH[Map.Hex[x][y].Alt]+BuildingHeight - Altitude) mpc = 1;
    else Move = Off; // Not Enough MP
  }

  if (Move == Off) mpc = 20;

return mpc;
}
*/
