/////////////////////////////////////////////////////////////////////////////
// Functions to load the more complicated .MEC Files
//
//
//

/*
typedef struct rWeaponData {
char Type;  // SMLS / MDLS
int  Loc ;
int  Ammo;  // -1 Energy
int  Damage;
char Status;
};

typedef struct rMechCriticals {
char Class;  // Engine / Actuators / Weapons / Ammo
char Type;   // SMLS / MDLS .. etc
char Size;
char Status;  // 0 = OnLine, 1 .. 8 OffLine
};

class rMech {
public:
int  TechBase;

char Name[40];
char Code[40];
int  Type;
int  Tons;
int  Walk;
int  Run;
int  Sprint;
int  Jump;

int  HeatSinks;

int  EngineType;
int  GyroType;
int  CockPitType;
int  SensorType;

int  MyomerType;
int  StructType;
int  ArmourType;
int  HeatSinkType;

int  NullSigType;
int  HatchetType;
int  BAPType;
int  ECMType;
int  CompType;
int  ARTType;

int  CaseType;
int  CaseLoc;

int LeftArm,RightArm;
int Armour[12];
int Struct[12];

int PrimeWeapon;

int Weapons;
WeaponData Weapon[40];

int CritSlot[12];
MechCriticals Crit[8][12];

};
*/
int LoadMech(class Mech &Mech, char *Name)
{
char String[30];
FILE *MechOut;

sprintf(String,"%s.mec",Name);

MechOut = fopen(String,"rb");
//checkFile(MechOut,5);

if (MechOut == NULL) return LoadHMP(Mech,Name);
/////////////////////////////////////////////////////////////////////////////
// File Header
// ALWAYS 12 BYTES in length
//

fgetc(MechOut);           // 0 - BattleMech 1 - Vehicle etc..
Mech.TechBase=fgetc(MechOut);    // 0 - InnerSphere 1 - StarLeague 2 - Clan 3 - Custom
readString(String,MechOut);  // File Class
fgetc(MechOut);           // IE Version 1.0, 2.0
fgetc(MechOut);           // IE Version  .2   .7
fgetc(MechOut);           // Release Version  / Alpha / Beta / Gamma

readString(Mech.Name,MechOut);
readString(Mech.Code,MechOut);
Mech.MechType=fgetc(MechOut);   //  0 - Biped 1 - Quad 2 - Lam 3 - OmniMech
Mech.Tons=fgetc(MechOut);
Mech.Walk=fgetc(MechOut);
Mech.Jump=fgetc(MechOut);

// Pod Weight?
//putc(HeatSinkType) // 0 - Normal 1 - Double 2 - Clan 3 - Compact 4 - Laser
Mech.HeatSinks=fgetc(MechOut);

Mech.LeftArm.Length =fgetc(MechOut); // The Arms Length, 2-4
Mech.RightArm.Length=fgetc(MechOut);

int i,j;             // 0 1 2 3 4 5 6 7 8 9 0
for (i=0;i<11;i++) {
  Mech.Armour[i]=fgetc(MechOut);
  }
for (i=0;i<8 ;i++) {
  Mech.Struct[i]=fgetc(MechOut);
  }

//printf("Armour\n");
// Derived

//int   MaxAF,CurAF;
//float MaxArmourTons,CurArmourTons;

//  putc(127,MechOut); // End Main
fgetc(MechOut);
// Put Equipment Type

Mech.EngineType  =fgetc(MechOut);
Mech.GyroType    =fgetc(MechOut);
Mech.CockPitType =fgetc(MechOut);
Mech.SensorType  =fgetc(MechOut);

Mech.MyomerType  =fgetc(MechOut);
Mech.StructType  =fgetc(MechOut);
Mech.ArmourType  =fgetc(MechOut);
Mech.HeatSinkType=fgetc(MechOut);

Mech.NullSigType =fgetc(MechOut);
Mech.BAPType     =fgetc(MechOut);
Mech.ECMType     =fgetc(MechOut);
Mech.C3Type      =fgetc(MechOut);
Mech.AMSType     =fgetc(MechOut);
Mech.MASCType    =fgetc(MechOut);
Mech.CompType    =fgetc(MechOut);
Mech.ARTType     =fgetc(MechOut);

Mech.CaseType    =fgetc(MechOut);
Mech.CaseLoc     =fgetc(MechOut);

Mech.RightHatchetType =fgetc(MechOut);
Mech.LeftHatchetType  =fgetc(MechOut);

//  putc(127,MechOut); // End Type
fgetc(MechOut);
//genWeaponTable();
Mech.Weapons=fgetc(MechOut);
for (i=0;i<Mech.Weapons;i++) {
//  Mech.Weapon[i].Type=fgetc(MechOut)+1;
  Mech.Weapon[i] = WeaponTable[fgetc(MechOut)];
  Mech.Weapon[i].Loc =fgetc(MechOut);
  Mech.Weapon[i].State = 1;
  }

fgetc(MechOut);
// putc(127,MechOut); // End Weapon

for (i=0;i<8;i++) {
  Mech.CritSlot[i]=fgetc(MechOut);
  for (j=0;j<Mech.CritSlot[i];j++) {
    Mech.Crit[i][j].Class =fgetc(MechOut);
    Mech.Crit[i][j].Type  =fgetc(MechOut);
    Mech.Crit[i][j].Size  =fgetc(MechOut);
    Mech.Crit[i][j].State =fgetc(MechOut);
    }
  }
//  putc(127,MechOut); // End Crit
//fgetc(MechOut);
//Put Terminators

fgetc(MechOut);
fclose(MechOut);

Mech.Run      = (Mech.Walk * 3 + 1) / 2;
Mech.Position = 1; // Mech starts Standing, height equals 1+1 level
Mech.Heat     = 0; // Mechs Start with no Heat
Mech.Holding  =-1; // Mechs Start out not Holding Anything
Mech.Carrying =-1; // Mechs Start out not Carrying any one
Mech.Size     = 2; // Mech Height

Mech.Status   = 1;
Mech.Stacked  = Off;
Mech.MASCNumber=3;

Mech.EngineHits      = 0;
Mech.GyroHits        = 0;
Mech.SensorHits      = 0;
Mech.LifeSupportHits = 0;

Mech.RightArm.Shoulder = On;
Mech.RightArm.UpperArm = On;
if (Mech.RightArm.Length >= 3) Mech.RightArm.LowerArm = On;
if (Mech.RightArm.Length == 4) Mech.RightArm.Hand     = On;
Mech.LeftArm.Shoulder  = On;
Mech.LeftArm.UpperArm  = On;
if (Mech.LeftArm.Length >= 3) Mech.LeftArm.LowerArm  = On;
if (Mech.LeftArm.Length == 4) Mech.LeftArm.Hand      = On;
Mech.RightLeg.Hip      = On;
Mech.RightLeg.UpperLeg = On;
Mech.RightLeg.LowerLeg = On;
Mech.RightLeg.Foot     = On;
Mech.LeftLeg.Hip       = On;
Mech.LeftLeg.UpperLeg  = On;
Mech.LeftLeg.LowerLeg  = On;
Mech.LeftLeg.Foot      = On;

return 0;

}


