////////////////////////////////////////////////////////////////////////////
// Phases for main Mech Program
//
// Move
// MoveMech
// Weapon
// genToHit
// ResolveWeapons
//

int putString     (char *String,int Colour);
int getMoveType   (byte ch);

int Advance  ();
int TurnLeft ();
int TurnRight();
int WeaponPhase();
int CreateFire (int x, int y);
int CreateSmoke(int x, int y);
int DamageHex  (int x, int y, int Damage);
int ScrollUp   ();
int ScrollDn   ();
int ScrollLt   ();
int ScrollRt   ();
int ShowOptions();
int CentreMap  (int x, int y);
int ToggleShowWeapons();
int ToggleCentreMap  ();
int ToggleFastAI     ();
int SetAISpeed       ();

class Unit *SelectTarget(class Unit &target);
int  toggle(char weap);

////////////////////////////////////////////////////////////////////////////
// Movement Phase
//
//
//

int Unit::MovePhase()
{
// Select Move Options

// Player 1's Turn
// Walk 4 Run 6 Jump 6 ? info
// (Move) ?Info

//if (Pilot.AIMovePhase == On) return AIMovePhase(unit[Index]) ; // AI Control
if (Options.MovePhase == Off || Immobile == On || Status == Off) return 0;

//drawScreen();

char iString[80],String[80],wString[15],rString[15],sString[15],jString[15],aString[15];
int i;

Reversed = 0;
//sprintf(String,"Player %d's Turn",Side);
//putString(String,Colour); // String Colour
//getkey();

sprintf(wString,"%s %d ",MoveCode[ Type ] [1],getSpeed(1));
//printf("1 %s  ",wString);

if (getSpeed( 1))
  sprintf(rString,"%s %d ",MoveCode[ Type ] [2],getSpeed( 2));
else
  sprintf(rString," ");
//printf("2 %s  ",rString);

if (getSpeed( 2))
  sprintf(sString,"%s %d ",MoveCode[ Type ] [3],getSpeed( 3));
//printf("2 %s  ",sString);

if (getSpeed(-1))
  sprintf(jString,"%s %d ",MoveCode[ Type ] [4],getSpeed(-1));
else
  sprintf(jString,"");

//printf("3 %s  ",jString);

  sprintf(aString,"%s",MoveCode[ Type ] [0]); // Mech Stands

if (Position)
  sprintf(iString,"%s %s%s%s%s",Name, wString,rString,jString,aString);
else
  sprintf(iString,"%s %s%s%s%s [PRONE]",Name, wString,rString,jString,aString,Heat);

  sprintf(String,"%-60s Heat %d ",iString,Heat);
//  sprintf(String,"%s%s%s",wString,rString,aString);
//  sprintf(String,"%s%s",wString,aString);

putString(String,Colour); // String Colour

MoveType = RETURNNULL;
while (MoveType == RETURNNULL)
  MoveType = getMoveType(getkey()),putString(String,Colour); // String Colour

MP = getSpeed(MoveType);
HexesMoved = 0;

i = 0;
char *StandFall[] = {"[P]rone",
                     "[S]tand",
                     0x0000};

while (i!=2 || MP > 0) {

if (MoveType >= 0) // Mech moving on land
  sprintf(iString,"%s   %s : %d [%d%c] %s",Name, MovType [Type][TypeCon[MoveType]] ,MP,Vector.head,248,Heat,StandFall[Position]);
else
  sprintf(iString,"%s   %s : %d [%d%c]",Name, MovType [Type][TypeCon[MoveType]] ,MP,Vector.head,248,Heat);

  sprintf(String,"%-60s Heat %d ",iString,Heat);

  putString(String,Colour);

  i=Move(getkey());
  }

if (MoveType < 0) // Mech is jump and can land any direction
  while (Move(getkey()) != 2);

return 0;
}
/*
int putString(char *String, char Colour)
{
textattr(Colour);
gotoxy(textbarx,textbary);
printf("                                                                       ");
gotoxy(textbarx,textbary);
cprintf("%s",String);
return 0;
}
*/

int putString(char *String, int Colour)
{
blit(topbordersprite, topbordertext, 0, 0, 0, 0, 640, 24); // Draw back ground onto another sprite Off Screen

//draw_sprite( screen, topbordersprite ,   0,  0);
sprintf(LastString,"%s",String);
LastColour = Colour;

textout(topbordertext,font,String,17,8,EGAColour[8]); // Write text on that other sprite
textout(topbordertext,font,String,16,7,EGAColour[8]);
textout(topbordertext,font,String,15,6,Colour);

blit(topbordertext, screen, 0, 0, 0, 0, 640, 24); // Put that sprite to the screen

vsync();
return 0;
}

int Unit::getMoveType(byte ch)
{
  switch (ch) {
    case 'w'  : ; return 1;
    case 'W'  : ; return 1;
    case 'r'  : ; return 2;
    case 'R'  : ; return 2;
    case 'j'  : ; return-1;
    case 'J'  : ; return-1;
    case 's'  : ; return 0;
    case 'S'  : ; return 0;
    case 125  : ;
    case 'i'  : getInfo() ;break;
    case 'I'  : getInfo() ;break;
    case QUIT : ExitGame(0) ; break;
    case CTRLG: ToggleGrid(); break;
    default   : ;break;
  }

return RETURNNULL;
}

int Unit::Advance()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
mpc = MPH[Map.Hex[Vector.x][Vector.y].Alt];
x = Vector.x + vec[Vector.head/30].x;
y = Vector.y + vec[Vector.head/30].y;

// if (AdvanceOpen())
// AdvanceOpen

for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
	MP = 0;
        }

  // Hex Open, Unit can Advance
if (x<=Xmin || x >= Xmax) // Mech Out Off bounds
  Move = Off,MP = 0; // Add Retreat

if (y<=Ymin || y >= Ymax) // Mech Out Off bounds
  Move = Off,MP = 0; // Add Retreat

if (Move == On) {
  drawHex(Vector.x,Vector.y);
  Vector.x = x;
  Vector.y = y;
  drawMech(Vector,Colour,Position);

  mpc = MPC[Map.Hex[Vector.x][Vector.y].Type] + abs(mpc - MPH[Map.Hex[Vector.x][Vector.y].Alt]);

  Altitude = MPH[Map.Hex[x][y].Alt];

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  MP -= mpc;
  HexesMoved ++;
  }

//  else Charge(Unit[i])

return Move;
}

int Unit::Reverse()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
mpc = MPH[Map.Hex[Vector.x][Vector.y].Alt];
i = Vector.head + 180;
if (i > 360) i -= 360;
if (i <   0) i += 360;
x = Vector.x + vec[i/30].x;
y = Vector.y + vec[i/30].y;

// if (AdvanceOpen())
// AdvanceOpen
if (MoveType == 1) {

for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
	}

  // Hex Open, Unit can Advance

if (x<=Xmin || x >= Xmax) // Mech Out Off bounds
  Move = Off,MP = 0; // Add Retreat

if (y<=Ymin || y >= Ymax) // Mech Out Off bounds
  Move = Off,MP = 0; // Add Retreat

if (Move == On) {
  drawHex(Vector.x,Vector.y);
  Vector.x = x;
  Vector.y = y;
  drawMech(Vector,Colour,Position);

  mpc = MPC[Map.Hex[Vector.x][Vector.y].Type] + abs(mpc - MPH[Map.Hex[Vector.x][Vector.y].Alt]);

  Altitude = MPH[Map.Hex[x][y].Alt];

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  MP -= mpc;
  HexesMoved ++;
  }
}
//  else Charge(Unit[i])

return Move;
}

int Unit::TurnLeft()
{
Vector.head -= 60;
if (Vector.head < 0) Vector.head += 360;
MoveType < 0 ? MP : MP -= 1; // If unit Jumps no MP cost

drawHex(Vector.x,Vector.y);
drawMech(Vector,Colour,Position);

return 1;
}

int Unit::TurnRight()
{
Vector.head += 60;
if (Vector.head >= 360) Vector.head -= 360;
MoveType < 0 ? MP : MP -= 1; // If unit Jumps no MP cost

drawHex(Vector.x,Vector.y);
drawMech(Vector,Colour,Position);

return 1;
}

class Unit *SelectTarget(class Unit &target) {
//class Unit *A;
int i=0;
while (target.Side == unit[i]->Side) i++;
return unit[i];
}

int Unit::InitiativePhase () {
if (Options.InitiativePhase == Off) return 0;
int Init = roll2d6 + Pilot.Reflexes;
return Init;
}



int AssessVictory(int Sides) {
int i;
int s[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

for (i=0;i<Units;i++)
  if ( unit[i]->Status == On ) s[unit[i]->Side] ++;

for (i=1;i<=Sides;i++)
  if (s[i] == 0) return i; // Return the side with no functional mech

return -1;
}

/*
int InitiativePhase() {
int i,j,a=0;
int Max;
int s[8];
int Roll[8];

for (i=0;i<Units;i++) {
  Roll[i] = unit[i]->InitiativePhase();
    if (Roll[i] > 0) s[unit[i]->Side] ++;
      }
        
if (Options.AlternateSides == On) {
  // Get the highest Score
    Max = 0;
    for (j=0;j<Units;j++)
      if (Roll[j] >= Max) {
        i = unit[j]->Side;
        Max = Roll[j];
        }
    // Side with highest value gets evey other

    for (j=0;j<Units;j++)
      if (unit[j]->Side == i) {
        Order[a] = j;
        a+=2;
        }
    a = 1; // Losing Side
    for (j=0;j<Units;j++)
      if (unit[j]->Side != i) {
        Order[a] = j;
        a+=2;
        }

  return Units;
  }
// Else
  for (i=0;i<Units;i++) {
    Max = 0;
    for (j=0;j<Units;j++)
      if (Roll[j] >= Max) {
        Order[i] = j;
        Max = Roll[j];
        }
    Roll[Order[i]] = 0;
    }

return Units;
}
*/
int OtherSide (int Loser) {
switch (Loser) {
case 1 : return 2;
case 2 : return 1;
default: return 0;
};
return 0;
}


int SaveBattleReport(int Sides,int Loser) {
int i,j,k;
char *State[] = {
                 "Destroyed",
                 "Functional",
                 0x0000};
char *Conc [] = {
                 "Unconscious",
                 "Conscious",
                 0x0000};

if (Options.SaveBattleReport==Off) return 1;
//textattr(02);
printf("Side %d Victorious!\r\n",OtherSide(Loser));
for (i=0;i<Units;i++)
  if (unit[i]->Side != Loser) {
    printf("[%s] : [%s]\r\n",unit[i]->Name,State[unit[i]->Status]);
    printf("[%s]    Hits : %d [%s]\r\n",unit[i]->Pilot.Name,unit[i]->Pilot.Hits,Conc[unit[i]->Pilot.Conscious]);
    }
//textattr(04);
for (i=0;i<Units;i++)
  if (unit[i]->Side == Loser) {
    printf("[%s] : [%s]\r\n",unit[i]->Name,State[unit[i]->Status]);
    printf("[%s]    Hits : %d [%s]\r\n",unit[i]->Pilot.Name,unit[i]->Pilot.Hits,Conc[unit[i]->Pilot.Conscious]);
    }
    
return 0;
}

int Surrender (int SurrenderSide) {
/*Prompt*/
//Set Background Attributes to 07
BITMAP *block;
block = create_bitmap(250,100);
char ch;
int i;

blit    (screen,block,180,180,0,0,250,100);

rectfill(screen,180,180,400,260,Window.BGColour);
textprintf(screen,font,200,200,Window.TextColour,"Side %d Surrender ? (Y/N)",SurrenderSide);
ch = getkey();

blit    (block,screen,0,0,180,180,250,100);

if (ch == 'y' || ch == 'Y') {
  for (i=0;i<Units;i++) {
    unit[i]->Immobile = On;
      if (unit[i]->Side == SurrenderSide)
        unit[i]->Status = Off;
      }
  return 1;
  }

return 0;
};

