
typedef unsigned char  byte;
typedef unsigned short word;
typedef short          int16;

enum { Head , CentreTorso , RightTorso , LeftTorso, RightArm , LeftArm ,\
       RightLeg , LeftLeg, RearCentreTorso , RearRightTorso , RearLeftTorso };

enum { HD , CT, RT, LT, RA, LA, RL, LL, CTr, RTr, LTr, RAr, LAr, RLr, LLr, HDr};

enum { Front, Right, Left, Rear, Turret };

enum { FR, RS, LS, BK, TR };

////////////////////////////////////////////////////////////////////////////
//    _
//   / \    30->X20V
//  |   |   T2  Trees, level 2
//   \_/

//  x * y  =
// 17 * 2 + 1   * 16 = 560
// 560 * 6 = 3360 bytes / Map

typedef struct HexData {
char Type; // Forest / Clear
char Cond; // Snow / Sand
char Road; // ( ) None 0 - lvl 0 road 3 - lvl 3 road C (3+An) lvl 3 road with a river at altitude
char Alt ; // Altitude  -10 / 10 levels
char Fire; // Fire / Smoke flag
char Index; // + If a building / Geyser, else -1
};

typedef struct MapData {
HexData Hex[136][64];
int  x1,y1,x2,y2;
};

typedef struct OldMapData {
char hex[68][32]; // Only needs half
int  x1,y1,x2,y2;
};

typedef struct Vector {
int x;
int y;
int head;
};

/*
typedef struct WeaponTable {
char Name[30];
int Dam,Mis,Heat;
int Min,Sht,Med,Lng;
int Crit,Ammo;
int Tons;
};
*/
class Pilot {
public:
char Name[20];
int Gunnery;
int Piloting;
int Hits;
int Stun;      // #Turns Unit stunned
int Conscious; // Unit Active or not
int Build;
int Reflexes;
int Intellegence;

int Target;  // Unit Index
int TargetPenalty;

int Aim;
int AimTarget;

int LatShift;
int Sprint;
int Evade;

int FallBonus;
int StandBonus;

int AILevel; // 0 = Player, 1 = Idiot 10 = Genius
int AIInitiativePhase;
int AIMovePhase;
int AIReactionPhase;
int AIWeaponPhase;
int AIPhysicalPhase;
};

typedef struct MechCriticals {
char Class;  // Engine / Actuators / Weapons / Ammo
char Type;   // SMLS / MDLS .. etc
char Size;
int  State;  // 0 = OnLine, 1 .. 8 OffLine
};

typedef struct WeaponData {
int  Type;  // SMLS / MDLS
int  Loc ;
int  Ammo;  // -1 Energy
int  Damage;
char Status;
};

typedef struct AmmoData {
int  Type;  // MachineGun
int  AmmoType; // Tracer / Inferno etc. 0 = Standard
int  Loc ;  // CT
int  Pos ;  // Slot #11
int  Ammo;  // Rounds Contained
int  Damage; // Damage per burst
char Status;
};

typedef struct MechArmState {
char Length; // 2 = Locust / 3 = Warhammer / 4 = Atlas
char Punch;  // Damage
char Shoulder;
char UpperArm;
char LowerArm;
char Hand;
char State;
};

typedef struct MechLegState {
char Kick;  // Damage
char Hip;
char UpperLeg;
char LowerLeg;
char Foot;
char State;
};

typedef struct Side {
int Loyalty;
};

typedef struct Graphic {

char Ascii;
byte Colour;

};

typedef struct PhysicalAttack {
int Target;
int Damage;
int Group;
int Table;
int Fall;
};

class Unit {
public:
class Pilot Pilot;

char Name[30];
//char SpriteName[30];
char Type;
int  Index;
int  Side;

int  Used;

int  Size; // Height 0=Vehicle, 1 = Mech
int  Status;
int  Colour;
char UnitColour; //
char Position; // 1 = Standing / 0 = Prone
int  Altitude; // Height above ground
int  Reversed; // Can't Charge
int  Submersed;
//int  OnRoad;
int  Hidden;

int  Immobile;
int  Heat;
int  HeatTurn; // Heat generated by Fire
int  Infernos; // # of turns Infernos last
int  Turret;

int  Holding;  // -3 = Girder -2 = Tree -1 Nothing, 0.. Item[0..]
int  Carrying; // -1 No unit, 0.. Unit[0..]
int  Mounted;  // -1 Not Mounted, 0.. Riding on Unit[0..]

int  MoveType;
int  HexesMoved;
int  MP;

//AmmoData Ammo[16];

struct Vector Vector;
struct Vector LastVector; // Last safe spot
int    Stacked; // Sharing a hex

int  DamageAngle;

int  Weapons;     // Fix it Later
int  Ammunitions;
char Flag[16];
char WeaponTarget[16];
WeaponType Weapon[16];
AmmoTypes  Ammo[16];
int  PhysAttacks;
PhysicalAttack PhysAttack[2];
int  TurnDamage;
int  StartPosition;

class Unit      *u;
class Mech      *m;
class Vehicle   *v;
class Infantry  *i;
class Elemental *e;

  virtual int  getMoveType (byte);
  virtual int  Move	   (byte)       {return 0;};
  virtual int  Forward	   ()           {return 0;};
  virtual int  SetPosition ()           {return 0;};
  virtual int  Advance	   ();
  virtual int  Reverse     ();
  virtual int  TurnRight   ();
  virtual int  TurnLeft    ();
  virtual int  Shift       ()           {return 0;};
  virtual int  LateralShift(int)        {return 0;};


  virtual int  MovePhase      ();
  virtual int  WeaponPhase    ()                     {return 0;};
  virtual int  ResolveWeapon  (class Unit *Attacker,int,int,int) {return 0;};
  virtual int  ResolveWeapons (class Unit *Attacker) {return 0;};
  virtual int  ResolveWeaponsHex(struct Vector)      {return 0;};
  virtual int  genToHit       (class Unit)           {return 0;};
  virtual int  genToHitHex    (struct Vector)        {return 0;};
  virtual int  ShowWeaponFire (int Weapon,class Unit *Target){return 0;};
  virtual int  SetWeaponTarget(class Unit *Target)   {return 0;};
  virtual int  ResolveWeaponFire()                   {return 0;};
  virtual int  ResolvePhysicalAttacks()              {return 0;};

  virtual int  InitiativePhase()    ;
  virtual int  ReactionPhase  ()    {return 0;};
  virtual int  PhysicalPhase  ()    {return 0;};
  virtual int  HeatPhase      ()    {return 0;};
  virtual int  EndPhase       ()    {return 0;};
  virtual int  Retreat        (int) {return 0;};

  virtual int  AmmoState      (int , int ) {return 0;};
  virtual int  AmmoExplosion  (int )       {return 0;};

  virtual int  Damage      (int,int,int){return 0;};
  virtual int  Critical    (int,int)    {return 0;};
  virtual int  Return      ()           {return 0;};
  virtual int  getSpeed    (char)       {return 0;};
  virtual int  getWeapons  ()           {return 0;};
  virtual int  Show        ()           {return 0;};
  virtual int  ShowCrits   ()           {return 0;};
  virtual void WeaponSelect(int,int)    {};
  virtual int  getInfo     ();
  virtual int  getTarget   (int);

  virtual int  genPilotModifier()       {return 0;};
  virtual int  Skid        ()           {return 0;};
  virtual int  Shoved      (int )       {return 0;};
  virtual int  Fall        (int Height) {return 0;};
  virtual int  ConcRoll    ()           {return 0;};
  virtual int  getTons     ()           {return 0;};
  virtual int  UpdateVector(struct Vector Target) {return 0;};
  virtual int  Drop        (int )       {return 0;};
  virtual int  CalcBV      (int )       {return 100;};

  virtual int  drawUnit    (int )       {return 0;};

  virtual WeaponType getWeapon (int a) {return Weapon[a];};

  virtual int  MouseMove      (int)     {return 0;};

  virtual int  AIMovePhase    ()        {return 0;}; // AI Phases
  virtual int  AIReactionPhase()        {return 0;};
  virtual int  AIWeaponPhase  ()        {return 0;};
  virtual int  AIPhysicalPhase()        {return 0;};

  virtual int  AIWeaponSelect (int)     {return 0;};
//  virtual int  AIGetMoveCost  (Vector,Vector)       {return 0;};

//  virtual class Mech getMech   ()    {class Mech a; return a;};

};

class Mech : public Unit {
public:

char Code[15];
char TechBase;
char MechType; // Biped / Quad / Omni / LAM
int Tons;

int Walk;
int Run;
int Sprint;
int Jump;
int HeatSinks;
int HeatDisp;
int HeatSinkType;
int ShutDown;
int EngineHits;
int GyroHits;
int LifeSupportHits;
int SensorHits;

char StructType;
int Struct[15];
int MaxStruct[15];
char ArmourType;
int Armour[15]; // Should be 11 - for every area
int MaxArmour[15];

int CritSize[8];
int CritSlot[8];
MechCriticals Crit[8][12];

MechArmState RightArm, LeftArm;
MechLegState RightLeg, LeftLeg;
int RightMelee, LeftMelee;

//  int    Move          ()         {return 0;};
  int    Damage        (int, int, int);
  int    InternalDamage(int, int, int);
  int    Destroy       (int);
  int    Sever         (int);
  int    Critical      (int, int);
  int    CriticalDamage(int, int);
  int    WeaponDisable (int, int);
  int    TransferCrit  (int, int);
  int    getSpeed      (char a);
//  int    getSpeed      (char a)   {int c = a>0?a>1?a>2?Sprint:Run : Walk :a<0?Jump:0; return c;};
  int    getWeapons    ()         {return Weapons;};
//  WeaponData getWeapon (int a)    {return Weapon[a];};
  int    getTons       ()         {return Tons;};
  int    AmmoState     (int , int );
  int    AmmoExplosion (int , int );
  int    Show          ();
  int    ShowCrits     ();
  void   WeaponSelect  (int , int );
  int    ConfigWeapons ();
  int    ToggleFireRate();
  int    EjectAmmo     ();
  int    SetAmmoType   (int , int );
  int    getMoveType   (byte);
  int    WeaponAmmo    (int , int );
  int    EngageMASC    ();
  int    Move	       (byte);
  int    SetPosition   ();
  int    Forward       ();
  int    Advance       ();
  int    Reverse       ();
  int    TurnRight     ();
  int    TurnLeft      ();
  int    Shift         ();
  int    LateralShift  (int);
  int    validQuad     ();
  int    Retreat       ();
  int    HullIntegrity ();

  int    AimedShot     ();
  int    AimTarget     (class Unit *Target);
  int    CallTarget    (class Unit *Target);
  int    SetRateOfFire ();
  int    SetAmmoTypes  ();
  
  int    ResolveWeapon (class Unit *Attacker, int, int, int);
  int    ResolveWeapons(class Unit *Attacker);
  int    genToHit      (class Unit  );
  int    ShowWeaponFire(int Weapon,class Unit *Target);
  int    SetWeaponTarget(class Unit *Target);
  int    ResolveWeaponsHex(struct Vector);
  int    genToHitHex      (struct Vector);
  int    ConcRoll       ();
  int    ReactorShutDown();
  int    CalcBV         (int );

  int    ResolveWeaponFire();
  int    ResolvePhysicalAttacks();

  int    Fall          (int );
  int    Skid          ();
  int    Stand         ();
  int    Prone         ();
  int    Shoved        (int );
  int    Retreat       (int ) {return 0;};
  
  int    Club          (class Unit *, int, int);
  int    Punch         (class Unit *, int);
  int    Kick          (class Unit *);
  int    Push          (class Unit *);
  int    Charge        (class Unit *);
  int    DFA           (class Unit *);
  int    Swat          (class Unit *, int);

  int    genPilotModifier();
  int    genAmmoTable();

  int    InitiativePhase();
  int    MovePhase      ();
  int    ReactionPhase  ();
  int    WeaponPhase    ();
  int    PhysicalPhase  ();
  int    HeatPhase      ();
  int    EndPhase       ();

  int    drawUnit       (int );

  class  Mech getMech   ()         {class Mech a = *m; return a;};

  int    MouseMove      (int);

  int    AIMovePhase    (); // AI Phases
  int    AIReactionPhase();
  int    AIWeaponPhase  ();
  int    AIPhysicalPhase();

  int    AIWeaponSelect (int);
//  int    AIGetMoveCost  (Vector, Vector);
  
  // Equipment Types
 int  EngineType;
 int  GyroType;
 int  CockPitType;
 int  SensorType;
 int  MyomerType;

 int  NullSigType;
 int  BAPType;
 int  ECMType;
 int  C3Type;
 int  AMSType;
 int  MASCType;
 int  CompType;
 int  ARTType;

 int  CaseType;
 int  CaseLoc;

 int  RightHatchetType;
 int  LeftHatchetType;
 int  MASCNumber;
 int  MASCState;
 int  TSMState;

};

class Vehicle : public Unit {
public:
char FileName[40];
int  TechBase;
int  Tonnage;
char VehicleType;
int  Cruise;
int  Flank;
int  Jump;
int  MainGun;
//int  State;
//int  TurretState;

int  Struct[10];
int  Armour[10];

int  Size;
int  Position;

char TurretState; // -1 No turret, 0 Good, 1..6 Turret locked in that position

// Functions

  int    InitiativePhase();
  int    MovePhase      ();
  int    WeaponPhase    ();
  int    EndPhase       ();

  int    Show           ();
  int    Move	        (byte);
  int    getMoveType    (byte);
  int    SetPosition    ();
  int    Advance        ();
  int    Reverse        ();
  int    TurnRight      ();
  int    TurnLeft       ();
  int    getSpeed       (char);
  void   WeaponSelect   (int , int );
  int    genToHit       (class Unit  );
  int    SetWeaponTarget(class Unit *Target);
  int    ShowWeaponFire (int Weap, class Unit *Target);
  int    Damage         (int Loc, int Facing, int Dam);
  int    Critical       (int );
  int    LockTurret     ();
  int    MotiveDamage   (int );
  int    ResolveWeapons (class Unit *Attacker);
  int    drawUnit       (int );
  int    genToHitHex    (struct Vector Target);
  int    ResolveWeaponsHex(struct Vector Target);
  int    ResolveWeaponFire();
  int    ResolveWeapon  (class Unit *Attacker, int ActiveWeapon, int x, int y);
  int    Retreat        ();
  int    AmmoState      (int , int);

  int    MouseMove      (int);

  int    AIMovePhase    (); // AI Phases
  int    AIWeaponPhase  ();

  int    AIWeaponSelect (int);

int  HeatSinks;

int  Control;
int  Lift;
int  PowerAmp;
int  Structure;

int  EngineType;
int  CockPitType;
int  SensorType;
int  ArmourType;
int  HeatSinkType;

int  NullSigType;
int  BAPType;
int  ECMType;
int  CompType;
int  ARTType;

int  CaseType;
int  CaseLoc;

int  Utility1;
int  Utility2;

int  APC;
int  Cargo;
int  Stealth;

};

class Infantry : public Unit {
public:
//char Name    [40];
char FileName[40];
char WeapName[40];
int  TechBase;

int  Men;
int  Speed;
int  Jump;
int  Armour;
int  Function;
int  Divisior;
int  Range;
char RangeMod[21];
int  Effect;
int  LegAttacks;
int  Swarms;
int  APC;
int  Tons;
int  Stealth;

// Functions

  int    InitiativePhase();
  int    MovePhase      ();
  int    WeaponPhase    ();

  int    Show           ();
  int    Move	        (byte);
  int    getMoveType    (byte);
  int    SetPosition    ();
  int    Advance        ();
  int    Reverse        ();
  int    TurnRight      ();
  int    TurnLeft       ();
  int    getSpeed       (char);
  void   WeaponSelect   (int , int );
  int    genToHit       (class Unit  );
  int    SetWeaponTarget(class Unit *Target);
  int    ShowWeaponFire (int Weap, class Unit *Target);
  int    Damage         (int Loc, int Facing, int Dam);
  int    ResolveWeapons (class Unit *Attacker);
  int    drawUnit       (int );
  int    genToHitHex    (struct Vector Target);
  int    ResolveWeaponsHex(struct Vector Target);
  int    ResolveWeaponFire();
  int    ResolveWeapon  (class Unit *Attacker, int ActiveWeapon, int x, int y);
  int    LegAttack      ();
  int    Swarm          ();
  int    SwarmDamage    ();
  int    Retreat        ();
  int    Drop           (int );

  int    MouseMove      (int);

  int    AIMovePhase    (); // AI Phases
  int    AIWeaponPhase  ();
  int    AIWeaponSelect (int);


};

class Elemental : public Unit {
public:
//char Name    [40];
char FileName[40];
char WeapName[40];
int  TechBase;

int  Men;
int  Speed;
int  Jump;
int  Armour[10];
int  LegAttacks;
int  Swarms;
int  APC;
int  Tons;
int  Stealth;

// Functions

  int    InitiativePhase();
  int    MovePhase      ();
  int    WeaponPhase    ();

  int    Show           ();
  int    Move	        (byte);
  int    getMoveType    (byte);
  int    SetPosition    ();
  int    Advance        ();
  int    Reverse        ();
  int    TurnRight      ();
  int    TurnLeft       ();
  int    getSpeed       (char);
  void   WeaponSelect   (int , int );
  int    genToHit       (class Unit  );
  int    SetWeaponTarget(class Unit *Target);
  int    ShowWeaponFire (int Weap, class Unit *Target);
  int    Damage         (int Loc, int Facing, int Dam);
  int    ResolveWeapons (class Unit *Attacker);
  int    drawUnit       (int );
  int    genToHitHex    (struct Vector Target);
  int    ResolveWeaponsHex(struct Vector Target);
  int    ResolveWeaponFire();
  int    ResolveWeapon  (class Unit *Attacker, int ActiveWeapon, int x, int y);
  int    LegAttack      ();
  int    Swarm          ();
  int    SwarmDamage    ();
  int    getMen         ();
  int    Retreat        ();
  int    AmmoState      (int , int);
  int    Drop           (int );

  int    MouseMove      (int);
  int    AIMovePhase    (); // AI Phases
  int    AIWeaponPhase  ();
  int    AIWeaponSelect (int);

};


class Item { // Items Cannot move or Fire
public:

char Name    [30]; // Item Name
int  Index;        // Unit it came from

int  Owner;    // Unit that contains it, -1 MAP
int  Side;     // Side that has it
char Type;     // 1 = Arm 2 = Gun
char Club;     // 0 Not Club, 1 = Club
char Gun;      // Can be used in weapon Phase

int  Weapons;
int  Weapon[4];
int  Ammo[4];

int  Status;   //
char Colour;

struct Vector Vector; // Position

int Armour,Struct; // Inherited from Mech

  int  Drop     ()      {return 0;};
  int  PickUp   ()      {return 0;};
//  int  CreateArm(int,int,int);

};

class GameWindows {
public: // Colours and such
int TextColour;
int TextHighLightColour;
int FGColour;
int BGColour;
} Window;


Vector Cursor;

class GameOptions {
public:
// Display Phases
int InitiativePhase;
int MovePhase;
int ReactionPhase;
int WeaponPhase;
int PhysicalPhase;
int HeatPhase;
int EndPhase;

int CompressReactionPhase;
int SimultaneousWeaponFire;
int SimultaneousPhysicalAttacks;
int InitiativeBySide; // Side 1 moves the Side 2
int MoveUnitsBySide; // Move every mech on side 1
int AutoPick;

int Stacking;

int ShowSpritePCX;
int CreateFire;

int ShowShore;
int ShowHills;

int DrawGrid;   // Draws Hexaganol grid on map
int HighLight;
int RedrawLowLights;
int ShowWeaponFire; // Shows little animations
int CentreMap;

int GlancingHits;   // Half damage on exact roll
int FloatingCrits;  //
int CriticalHits;   // Critical Hits / On / Off
int TransferDamage;
int TwentyPointFalls;
int SkilledEvade;
int AimedShots;
int CalledShots;
int WeaponJams;
int HeadShots;
int GlancingHeadHits;
int MissileBonus;   // Adds to missile cluster
int AllSprint;
int AllEvade;

int LOSBlock;
int ElectronicLOS;
int LinearGunnery;
int LinearPiloting;

int AltitudeDisplay;
int AmmoExplosions;
int AmmoConsumption;
int ExtremeRange;
int MoveFire;   // Compress MoveMent/Fire into one Turn
int ModeratedAmmoExplosions;
int AutoMove;   // Automatically Move
int AutoWeapons;// Automatically Target and fire
int PilotShutDownBonus;
int MASCLocks;
int AngleOfAttack;
int HexFacings; // Side of Battlemech is determined from hexside entered

int ShowTargetTerrain;// shows Terrain before target
int AutoTarget; // Automatically Target the Closest Enemy
int MultiTarget;// Allow Multile engagements in a Turn

int ChargeMoves;
int Retreat;    // Unit can leave map
int AlternateSides;
int SaveBattleReport;
int FastAI;
float Gravity;
int FractionalCover;
int CumulativeTwentyPointFalls;
int RunInWater;
int AltChangeLimit;
int Level3VehicleCrits;
int MouseMove;
int MovementDice;
int ClubHitsPunch;
} Options;


