//////////////////////////////////////////////////////////////////////////////
// MechWar 3025 Vehicle Loader
//
//
//
/*
enum {Tracked,Wheeled,Hover};

enum {SingleHS,DoubleHS};
enum {Fusion,FusionXL,ICE};

enum {FL,LL,ML,SL,PPC,AC2,AC5,AC10,AC20,MG,LRM5,LRM10,LRM15,LRM20,SRM2,SRM4,SRM6};
enum {aAC2,aAC5,aAC10,aAC20,aMG,aLRM5,aLRM10,aLRM15,aLRM20,aSRM2,aSRM4,aSRM6};


//typedef struct {
char Name[40];
char FileName[40];
int  TechBase;
int  Tonnage;
int  VehicleType;
int  Cruise;
int  Flank;
int  Jump;
int  State;
int  Turret;

int  HeatSinks;

int  Control;
int  Lift;
int  PowerAmp;
int  Structure;

int  EngineType;
int  CockPitType;
int  SensorType;
int  ArmourType;
int  HeatSinkType;

int  NullSigType;
int  BAPType;
int  ECMType;
int  CompType;
int  ARTType;

int  CaseType;
int  CaseLoc;

int  Utility1;
int  Utility2;

int  APC;
int  Cargo;
int  Stealth;

int  Struct[10];
int  Armour[10];

int  Weapons;
int  Weapon[10]; // Weapon Type (iw Small Laser)
int  WeapLoc[10];
int  Ammos;
int  Ammo[10]; // Ammo Type (ie SRM 2 Ammo)
int  AmmoLoc[10];

//} Infantry;

int writeString(char *String, FILE *fout) {
int i = 0;
while (String[i] != 0x0000) fputc(String[i],fout), i++;
fputc(0x0000,fout); // Write a Terminator to the File
return i;
}
*/
int LoadVehicle(class Vehicle &Arm, char *Name) {
char String[30];
FILE *ArmIn;
int i;

sprintf(String,"%s.vec",Name);

ArmIn = fopen(String,"rb");
checkFile(ArmIn,8);
if (ArmIn == NULL) return 1;

/////////////////////////////////////////////////////////////////////////////
// File Header
// ALWAYS 12 BYTES in length
//

fgetc(ArmIn);           // 0 - BattleMech 1 - Vehicle etc..
Arm.TechBase=fgetc(ArmIn);    // 0 - InnerSphere 1 - StarLeague 2 - Clan 3 - Custom
readString(String,ArmIn);  // File Class
fgetc(ArmIn);           // IE Version 1.0, 2.0
fgetc(ArmIn);           // IE Version  .2   .7
fgetc(ArmIn);           // Release Version  / Alpha / Beta / Gamma

readString(Arm.Name    ,ArmIn);
readString(Arm.FileName,ArmIn);

Arm.Tonnage     =fgetc(ArmIn);
Arm.VehicleType =fgetc(ArmIn);

Arm.Cruise      =fgetc(ArmIn);
Arm.Jump        =fgetc(ArmIn);
Arm.TurretState =fgetc(ArmIn);

Arm.HeatSinks   =fgetc(ArmIn);
Arm.APC         =fgetc(ArmIn);
Arm.Cargo       =fgetc(ArmIn);
Arm.Stealth     =fgetc(ArmIn);

Arm.Control     =fgetc(ArmIn);
Arm.Lift        =fgetc(ArmIn);
Arm.PowerAmp    =fgetc(ArmIn);
Arm.Structure   =fgetc(ArmIn);

Arm.EngineType  =fgetc(ArmIn);
Arm.CockPitType =fgetc(ArmIn);
Arm.SensorType  =fgetc(ArmIn);
Arm.ArmourType  =fgetc(ArmIn);
Arm.HeatSinkType=fgetc(ArmIn);

Arm.NullSigType =fgetc(ArmIn);
Arm.BAPType     =fgetc(ArmIn);
Arm.ECMType     =fgetc(ArmIn);
Arm.CompType    =fgetc(ArmIn);
Arm.ARTType     =fgetc(ArmIn);

Arm.CaseType    =fgetc(ArmIn);
Arm.CaseLoc     =fgetc(ArmIn);

Arm.Utility1    =fgetc(ArmIn);
Arm.Utility2    =fgetc(ArmIn);

for (i=0;i<10;i++)
  Arm.Struct[i]=fgetc(ArmIn);

for (i=0;i<10;i++)
  Arm.Armour[i]=fgetc(ArmIn);

Arm.Weapons    =fgetc(ArmIn);

for (i=0;i<Arm.Weapons;i++) {
  Arm.Weapon[i] = WeaponTable[fgetc(ArmIn)];
//  Arm.Weapon[i].Type=fgetc(ArmIn);
  Arm.Weapon[i].Loc =fgetc(ArmIn);
  Arm.Weapon[i].State = 1;
  }

Arm.Ammunitions=fgetc(ArmIn);

for (i=0;i<Arm.Ammunitions;i++) {
  Arm.Ammo[i] = AmmoTable[fgetc(ArmIn)];
//  Arm.Ammo[i].Type=fgetc(ArmIn);
  Arm.Ammo[i].Loc =fgetc(ArmIn);
  Arm.Ammo[i].Ammo=AmmoTable[Arm.Ammo[i].Type].Ammo;
  }

//Put Terminators
fclose(ArmIn);

Arm.Status      = On;
Arm.Flank       = int ( ( Arm.Cruise * 1.5) + .5);
Arm.Size        = 1;
Arm.Position    = 1;
Arm.TurretState = 0;

return 0;
}
